<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Auth;
use Carbon\Carbon;

class Broadcast extends Model
{


    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
       'name',"broadcast_type","group_id","sch_date","sch_time"
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
     public function getCreatedatAttribute($value)

    {
        $timezone = \App\Setting::where("user_id",Auth::User()->id)->value("timezone");
        $timezone = preg_replace('/\-/', '/', $timezone);
          if($timezone=='' || $timezone==null){
            $timezone = 'America/Chicago';
          }
          //echo $timzon;
        $date =  Carbon::createFromFormat('Y-m-d H:i:s', $value, 'UTC')
        ->setTimezone($timezone);
        return  $date;

    }
    
    public function user(){
        return $this->belongsTo('App\User');
    }
    
}
