<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Setting;
use App\ServicePhone;
use App\Group;
use App\GroupContact;
use App\SmsService;
use App\Campaign;
use Carbon\Carbon;
use App\CampaignGroup;
use App\Offer;
use App\Followup;
use App\Chat;
use App\Contact;
use App\Broadcast;
use App\BroadcastSmsHistory;
use App\TwowayConversation;
use Auth;
use Yajra\Datatables\Datatables;
use App\Jobs\SendImmidiateSmsBroadcast;
use DB;
use Response;

class BroadcastController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view("admin.broadcast.list",[]);
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $Group = Group::where("user_id",Auth::User()->id)->get();
        return view("admin.broadcast.create",["groups"=>$Group]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $schedule = 0;
        $change_in_queue_jobs = 0;
        $user_id  = (isset($_REQUEST['user_id'])?$_REQUEST['user_id']:Auth::User()->id);
        $obj = new Broadcast();
        if($request->id!="")
        {
           $obj = $obj->findOrFail($request->id);

            //compare old schedule date and time with new
            if( ($obj->sch_date != $request->sch_date) || ($obj->sch_time != $request->sch_time) ){
                $change_in_queue_jobs = 1;
            }

        }
        $obj->fill($request->all());
        $obj->group_id = $request->group_id;
        $obj->user_id = $user_id;
        $obj->text = $request->text;
        if($obj->save())
        {
            //echo $change_in_queue_jobs;
            if($change_in_queue_jobs>0){
                $del = DB::table("jobs")->where('broadcast_id',$obj->id)->delete();
                if($del){
                    $request->id = '';
                }
            }
            
            //if sub_date or start_time changed $request->id will be ''
            if($request->id=="")
            {
                $from_detail = Setting::where('user_id','=',$obj->user_id)->first();
                $timezone_val = $from_detail->timezone;
                $timezone = preg_replace('/\-/', '/', $timezone_val);
                if($timezone_val=='' || $timezone_val==null){
                    $timezone = 'America/Chicago';
                }
                date_default_timezone_set($timezone);
                
                //for immediate broadcast
                if($obj->broadcast_type == 'immediate'){
                    $immediate = 1;
                    $add_days_to        = Carbon::createFromFormat('Y-m-d H:i:s', Carbon::now());

                }
                
                //start schedule broadcast settings
                if($obj->broadcast_type == 'schedule'){

                    $schedule = 1;

                    if( ($obj->sch_date!=null || $obj->sch_date!='') && ($obj->sch_time!='' || $obj->sch_time!=null) ){

                        $date_time          = $obj->sch_date." ".$obj->sch_time;
                        $schedule_dateTime  = Carbon::createFromFormat('Y-m-d h:i a', $date_time);
                        $schedule_dateTimeString  = strtotime($schedule_dateTime);

                        $add_days_to        = Carbon::createFromFormat('Y-m-d h:i a', $date_time);

                        $now                = Carbon::now();
                        $now_timeString     = strtotime($now);

                    }else{
                        $schedule = 0;
                    }
                }
                    $subscribers = GroupContact::where("group_id",$request->group_id)
                    ->get();
                    //echo count($subscribers);
                    if(count($subscribers)>0){
                        $counter = 1;
                        $tags = array("%first_name%", "%last_name%","%email%", "%phone%", "%city%", "%state%", "%zip%");
                        foreach($subscribers as $k=>$row){
                            $row = Contact::where("id",$row->contact_id)->where("status",1)->first();
                            if($row)
                            {
                                $vals = array($row->first_name, $row->last_name,$row->email, $row->phone, $row->city, $row->state, $row->zip);
                                $text = str_replace($tags,$vals,$obj->text.$from_detail->append_text); 
                                $data = array(
                                                'group_id' => $request->group_id,
                                                'text' =>$text,
                                                'broadcast_user_id' => $obj->user_id,
                                                'broadcast_id' => $obj->id,
                                                'media_url' =>  '',
                                                'callbackUrl' => url('sms-status'),
                                            );
                                            if($schedule == 1){//schedule
    
                                            //if($now_timeString >= $schedule_dateTimeString){
                                            //$delayTime = $schedule_dateTime->addSecond(1*$counter);
                                            $delayTime = $schedule_dateTime->addSecond(1);
                                            $job = (new SendImmidiateSmsBroadcast($row, $data,"sms"))
                                            ->delay($delayTime);
                                            $jobID = $this->dispatch($job);
                                            //}
    
                                        }else{//immediate
                                            //$delayTime = Carbon::now()->addSecond(1*$counter);
                                           // $delayTime = Carbon::now()->addSecond(1);
                                           $job = new SendImmidiateSmsBroadcast($row, $data,"sms");
                                            $jobID = $this->dispatch($job);
                                        }
                                            
                                           // var_dump($jobID);
                                            if($jobID > 0 && $obj->id > 0){
                                            DB::table("jobs")->where('id', $jobID)->update(['broadcast_id' => $obj->id]);
                                            }
                            }
                            
                        }
                    }
            }
            echo "1";
            
        }else
        {
            echo "0";
        }
        
        
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
       $data =  Broadcast::where("id",$id)->where("user_id",Auth::User()->id)->first();
       if($data)
       {
            $Group = Group::where("user_id",Auth::User()->id)->get();
            return view("admin.broadcast.create",["groups"=>$Group,"data"=>$data]);
       }else
       {
            echo "You are not authorize to access this.";
            return "";
       }
        
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    
    public function listBroadcast()
    {
        $data = Broadcast::where('user_id',Auth::user()->id);
		return Datatables::of($data)
		->addColumn('action',function($d){
		  $edit_url = url("/broadcast/$d->id/edit");
          $report = url("broadcast-sms-report/$d->id");
          $show_edit = "";
          if($d->broadcast_type=='immediate')
          {
             $show_edit = "display:none;";
          }else
          {
            $set = Setting::where("user_id",Auth::User()->id)->first();
            $timezone_val = $set->timezone;
            $timezone = preg_replace('/\-/', '/', $timezone_val);
            if($timezone_val=='' || $timezone_val==null){
                $timezone = 'America/Chicago';
            }
            $time  = strtotime(Carbon::now($timezone)->format('Y-m-d h:i a'));
            $btime = strtotime($d->sch_date." ".$d->sch_time);
            if($time>$btime)
            {
                 $show_edit = "display:none;";
            }
          }
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
            <a style='$show_edit' class='dropdown-item' href='$edit_url'><i class='la la-edit'></i> Edit</a> 
            <a class='dropdown-item' href='$report'><i class='la la-bar-chart'></i> Report</a> 
            <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
            </div>
            </span>";
                        
            return $cc;
		})
      
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
         ->addColumn('stats',function($d){
          $send = BroadcastSmsHistory::where("broadcast_id",$d->id)->where("delivery_status","delivered")->count();
          $fail = BroadcastSmsHistory::where("broadcast_id",$d->id)->where("delivery_status","failed")->orWhere("delivery_status","undelivered")->count();
          return "$send/$fail";
        })
         ->addColumn('contacts',function($d){
          $cons = GroupContact::where("group_id",$d->group_id)->count();
          
          return "$cons";
        })
        
        ->rawColumns(['action'])
        ->make(true);
    }
    public function SmsStatuscallback(Request $request)
    {
       //mail("unique.munda7@gmail.com","SMS Status",print_r($request->all(),true));
       $his =   BroadcastSmsHistory::where('sms_sid',$request->SmsSid)->first();
       if($his)
       {
           // $res = $this->getError($request->SmsSid,$his->user_id);
           $error_messge = "uknown error message";
           $data = json_decode(file_get_contents("https://twilio-cms-prod.s3.amazonaws.com/documents/twilio-error-codes.json"),true);
           $ids = array_search('21610', array_column($data, 'code')); 
           if($ids!='')
           {
            $error_messge =  $data[$ids]['message'];
           }
            //echo 
            //$data = json_decode($res);
            $his->delivery_status = $request->MessageStatus;
            $his->from_number = $request->From;
           // $his->error = $error_messge;
            
            if($his->save())
            {
                        $broadcast =  Broadcast::where("id",$his->broadcast_id)->first();
                        $coversation = TwowayConversation::where("user_id",$broadcast->user_id)->where("from_num", $his->from_number)->where("to_num",$his->to_number)->first();
                        if(!$coversation)
                        {
                            
                            $coversation = new TwowayConversation;
                            $coversation->user_id = $broadcast->user_id;
                            $coversation->subscriber_id = $his->subscriber_id;
                            $coversation->from_num = $his->from_number;
                            $coversation->to_num = $his->to_number;
                            $coversation->is_read = "yes";
                            if($coversation->save())
                            {
                                //$conversation_id = $coversation->id;
                            }
                        }else
                        {
                            $coversation->is_delete = "no";
                            $coversation->save();
                        }
                        
                          $chats = Chat::where("sms_sid",$request->SmsSid)->first();  
                          if($chats)
                          {
                            $chats->status = $request->MessageStatus;
                            $chats->save();
                          }else
                          {
                            $conversation_id = $coversation->id;
                            $chat = new Chat;
                            $chat->send_to = $his->to_number;
                            $chat->send_from = $his->from_number;
                            $chat->body = $his->body;
                            $chat->sms_sid = $request->SmsSid;
                            $chat->direction = "outbound";
                            $chat->user_id = $broadcast->user_id;
                            $chat->conversation_id = $conversation_id;
                            $chat->subscriber_id = $his->subscriber_id;
                            $chat->status = $request->MessageStatus;
                            $chat->save();
                          }
                        
                        
                        
                    }
       }
                
            
       
       return "";
    }
    
    public function smsHistory(Request $request,$id)
    {
        $broadcast = Broadcast::find($id);
        return view("admin.broadcast.history",["bcast"=>$broadcast]);
    }
    
    public function smsBhis(Request $request)
    {
        $data = BroadcastSmsHistory::where('broadcast_id',$request->id);
		return Datatables::of($data)
      
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        
        
        ->rawColumns(['action'])
        ->make(true);
    }
    
    public function SmsCon(Request $request)
    {
        if(!isset($_REQUEST['echo']))
        {
            header('Content-Type: text/xml');
            echo "<Response></Response>";
        }
        //echo "yes";
        $Body 			= trim($request->Body);
        $SmsSid			= @$request->SmsMessageSid;
        $From 			= $request->From;
        $To				= $request->To;
        $req_data       = $request->all();
        if(strtolower($Body)=='stop')
        {
            Contact::where("phone",$From)->update(["status"=>0,"unsub_date"=>Carbon::now('UTC')->format("Y-m-d H:i")]);
        }
        
        if(strtolower($Body)=='start')
        {
            Contact::where("phone",$From)->update(["status"=>1]);
        }
        $ServiceId = ServicePhone::where("phone_number",$To)->value("sms_service_id");
        $service = SmsService::find($ServiceId);
        $subscriber = Contact::where("user_id",$service->user_id)->where("phone",$From)->first();
        if($subscriber)
        {
            $convo = TwowayConversation::where("user_id",$subscriber->user_id)->where("from_num",$To)->where("to_num",$From)->first();
        //var_dump($convo);
       // die();
            $chat = new Chat;
            $chat->user_id = $convo->user_id;
            $chat->send_to = $To;
            $chat->send_from = $From;
            $chat->sms_sid = $SmsSid;
            $chat->body = $Body;
            $chat->direction = "inbound";
            $chat->status = "received";
            $chat->msg_type = "chat";
            $chat->is_read = 0;
            $chat->conversation_id = $convo->id;
            $chat->subscriber_id = $subscriber->id;
            $chat->save();
            $convo->is_read = "no";
            $convo->save();
            
        }
        return "";
    }
    
    public function delBroadcast(Request $request)
    {
        $del =  Broadcast::where("id",$request->id)->delete();
      if($del)
      {
        DB::table("jobs")->where("broadcast_id",$request->id)->delete();
        echo "1";
      }else
      {
        echo "0";
      }
      return "";
    }
    
    public function listCons(Request $request)
    {
        //$data = TwowayConversation::where("user_id",Auth::User()->id);
        $user_id = Auth::User()->id;
        $data = TwowayConversation::join("contacts","contacts.id","=","twoway_conversations.subscriber_id")
            ->join("chats","contacts.id","=","chats.subscriber_id")
            ->select(['contacts.first_name',
            "twoway_conversations.from_num",
            "twoway_conversations.to_num",
            "twoway_conversations.is_delete",
            "twoway_conversations.id",
            "twoway_conversations.is_read",
            "twoway_conversations.is_flag",
            "chats.body",
            "chats.created_at"])
            ->withCount(["msgs"])
            ->where("twoway_conversations.user_id",$user_id)
            ->where("twoway_conversations.is_delete","no")
            ->whereIn('chats.id',function($query) use($request){
            $query->select(DB::raw('max(id) FROM chats'))
            ->whereRaw("conversation_id=twoway_conversations.id group by conversation_id order by conversation_id desc");
          });
        return Datatables::of($data)
		->addColumn('action', function ($ivrs) {
                
                
                    
                    //$b = '<a href="'. url("/broadcast/$camps->id/edit") .'" title="Edit" class="btn btn-xs btn-primary"><i class="glyphicon glyphicon-edit"></i></a> ';
                   
                    $b = '<a target="_blank" onclick="read_status('.$ivrs->id.')" href="'.url("/inbox-chat/").'?convo_id='.$ivrs->id.'" title="View Chat" class="btn btn-xs btn-info"><i class="fab fa-weixin"></i></a> ';
                    if($ivrs->is_delete=='no')
                    {
                        $b .= '<a style="color:white;" onclick="del_chat('.$ivrs->id.')" title="Delete Chat" class="btn btn-xs btn-danger"><i class="fa fa-trash"></i></a> ';
                    }
                    if($ivrs->is_read=="no")
                    {
                        $b .= '<a style="color:white;" onclick="set_status('.$ivrs->id.')" title="Mark as read" class="btn btn-xs btn-success"><i class="fa fa-check"></i></a> ';
                    }
                    $b .= '<a style="color:white;"   href="'.url("/export-chat/").'?convo_id='.$ivrs->id.'" title="Export Chat" class="btn btn-xs btn-warning"><i class="fa fa-download"></i></a> ';
                   // $b .= '<a onclick="unsub('.$camps->user_id.',\''.$camps->to_number.'\',\''.$camps->from_number.'\')" title="Unsubscribe" class="btn btn-xs btn-danger"><i class="fa fa-ban"></i></a> ';
                    return $b;
                
            })
      
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
         
        
        ->rawColumns(['action'])
        ->make(true);
    }
    
    public function inbox()
    {
        return view("admin.broadcast.inbox",[]);
    }
    public function exportChat(Request $request)
    {
        //header('Content-Type: text/plain');
        //header('Content-Disposition: attachment; filename="chat.txt"');
        $set = Setting::where("user_id",Auth::User()->id)->first();
          $timezone_val = $set->timezone;
          $timezone = preg_replace('/\-/', '/', $timezone_val);
          if($timezone_val=='' || $timezone_val==null){
            $timezone = 'America/Chicago';
          }
        $fp = fopen('php://output', 'w');
        $f=array("Sno","First Name","Last Name","Email Address","Phone", "Birthday", "Anniversary");
        $f[] = 'Added Date';
        
        if(isset($_REQUEST['convo_id']) && $_REQUEST['convo_id']!='')
        {
            $msgs = Chat::where("conversation_id",$_REQUEST['convo_id'])->get();
            
            $newmsg = "";
            foreach($msgs as $msg)
            {
                $date = $msg->created_at->timezone($timezone)->format('Y-m-d, h:i a');
                $name = $msg->send_from;
                if($msg->direction=='inbound')
                {
                    $name = Contact::where("id",$msg->subscriber_id)->value("first_name");
                    $name = ($name)?$name:$msg->send_from;
                }
                
                $newmsg.= "$name($date): $msg->body \n";
            }
            //0333 6662533
            
            
            //file_put_contents($fp, $newmsg);
              $fileName = "chat.txt";
    
                // use headers in order to generate the download
                $headers = [
                  'Content-type' => 'text/plain', 
                  'Content-Disposition' => sprintf('attachment; filename="%s"', $fileName),
                  'Content-Length' => strlen($newmsg)
                ];
            
                // make a response, with the content, a 200 response code and the headers
                return Response::make($newmsg, 200, $headers);
            //fclose($fp);  
            //die();
        
        }
    }
    public function chat(Request $request)
    {
        $conv = TwowayConversation::where("id",$request->convo_id)->where("user_id",Auth::User()->id)->first();
        if($conv)
        {
            TwowayConversation::where("id",$request->convo_id)->update(["is_read"=>"yes"]);
            $set = Setting::where("user_id",Auth::User()->id)->first();
          $timezone_val = $set->timezone;
          $timezone = preg_replace('/\-/', '/', $timezone_val);
          if($timezone_val=='' || $timezone_val==null){
            $timezone = 'America/Chicago';
          }
            $chat = Chat::where("conversation_id",$request->convo_id)->get();
            return view("admin.broadcast.chat",["chat"=>$chat,"conv"=>$conv,"timezone"=>$timezone]);
        }else
        {
            echo "Chat not found!";
        }
        return "";
        Chat::where("conversation_id",$request->conv_id)->get();
        return view("admin.broadcast.chat",[]);
    }
    public function send2waySmsChatsend($user_id,$twilio_num,$subnum,$body,$conversation_id,$subscriber_id,$send_by,$media='')
     {
        $sett = Setting::where("user_id",$user_id)->first();
        if($sett)
        {
            $sid = $sett->twilio_sid;
            $token = $sett->twilio_token;
            
            $url = "https://$sid:$token@api.twilio.com/2010-04-01/Accounts/$sid/Messages";
            $data = array(
            	"To"=>$subnum,
                "From"=>$twilio_num,
                "Body"=>$body
            );
            if($media!='')
            {
               $data['MediaUrl'] =  $media;
            }
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            $response = curl_exec($ch);
            curl_close($ch);
            $check = (array)simplexml_load_string($response);
          //  echo "<pre>";
           // print_r($check);
            //echo "<pre>";
           // print_r($check);
            $sid = "";
            if(!isset($check['RestException'])){
                   // ClientPackage::where('user_id', '=', $user_id)->increment("send_sms");
                    $delivery_status = 'delivered';
                    $sid = $check['Message']->Sid;
                    $return = true;
                }else
                {
                    $delivery_status='failed';
                    $return = false;
                }
            
                    
            $chat = new Chat;
            $chat->user_id = $user_id;
            $chat->send_to = $subnum;
            $chat->send_from = $twilio_num;
            $chat->sms_sid = $sid;
            $chat->body = $body;
            $chat->direction = "outbound";
            $chat->status = $delivery_status;
            $chat->msg_type = "chat";
            $chat->is_read = 1;
            $chat->conversation_id = $conversation_id;
            $chat->subscriber_id = $subscriber_id;
            $chat->save();
                
              
            return $return;
            //$body = str_replace(array("%phone%","%msg%",array("",""),$body));
        }
        
    }
    
    public function sendChat(Request $request)
    {
        $set = Setting::where("user_id",Auth::User()->id)->first();
          $timezone_val = $set->timezone;
          $timezone = preg_replace('/\-/', '/', $timezone_val);
          if($timezone_val=='' || $timezone_val==null){
            $timezone = 'America/Chicago';
          }
        $con = TwowayConversation::where("id",$request->convo_id)->first();
       $check =  $this->send2waySmsChatsend($con->user_id,$con->from_num,$con->to_num,$request->msg,$con->id,$con->subscriber_id,"user","");
       if($check)
       {
        
         $time  = Carbon::now($timezone)->format('Y-m-d h:i a');
        $html = "";
       $html .="<li class='admin clearfix'>";
       $html .=" <span class='chat-img right clearfix  mx-2'>";
       $html .="<img src='//placehold.it/50/FA6F57/fff&text=A' alt='Admin' class='img-circle' />";
       $html .="</span>";
       $html .="<div class='chat-body clearfix'>";
       $html .="<div class='header clearfix'>";
       $html .="<small class='left text-muted'>";
       $html .="<span class='glyphicon glyphicon-time'>$time</span></small> &nbsp;";
       $html .="<strong class='right primary-font'>Admin( $con->from_num )</strong>";
        
                                            
       $html .="</div>";
       $html .=" <p>$request->msg</p>";
       $html .=" <div></li>";
                                           
              echo $html;
              return "";                          
                                    
       }else
       {
        echo "0";
       }
       return "";
    }
    
    public function delConv(Request $request)
    {
        $del =  TwowayConversation::where("id",$request->id)->update(["is_delete"=>"yes"]);
      if($del)
      {
        echo "1";
      }else
      {
        echo "0";
      }
      return "";
    }
    
    public function setConvstatus(Request $request)
    {
        $chk = TwowayConversation::where("id",$request->id)->update(["is_read"=>"yes"]);
        
        if($chk)
        {
            echo "1";
        }else
        {
            echo "0";
        }
        
        return "";
    }
}
