<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Setting;
use App\ServicePhone;
use App\Group;
use App\SmsService;
use App\Campaign;
use Carbon\Carbon;
use App\CampaignGroup;
use App\Offer;
use App\Followup;
use App\Chat;
use App\Contact;
use Auth;
use Yajra\Datatables\Datatables;
use DB;

class CampaignController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view("admin.campaign.list",[]);
        
        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $Group = Group::where("user_id",Auth::User()->id)->get();
        $offers = Offer::where("user_id",Auth::User()->id)->get();
        return view("admin.campaign.create",["groups"=>$Group,"offers"=>$offers]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $respose = array();
        $respose['fol_id'] = array();
        $camp = new Campaign;
        if($request->id!='')
        {
            $camp = $camp->find($request->id);
        }
        $camp->fill($request->all());
        $camp->user_id = Auth::User()->id;
        if($camp->save())
        {
            if(isset($request->groups))
            {
                if(count($request->groups)>0)
                {
                    foreach($request->groups as $gp)
                    {
                        if(CampaignGroup::where("campaign_id",$camp->id)->where("group_id",$gp)->count()==0)
                        {
                            $cp = new CampaignGroup;
                            $cp->group_id = $gp;
                            $cp->campaign_id = $camp->id;
                            $cp->save();
                        }
                    }
                }
            }
            if(isset($request->oid))
            {
                $rem_arr = $request->oid;
            if(count($rem_arr)>0)
            {
                foreach($rem_arr as $rem_k=>$rem_v)
                {
                    $cm_obj = new Followup();
                    if($request->oid[$rem_k]!="")
                    {
                        $cm_obj = $cm_obj->findOrFail($request->oid[$rem_k]);
                    }
                    //$cm_obj->fill($rem_v);
                    $cm_obj->days_to_send = $request->days_to_send[$rem_k];
                    $cm_obj->time_to_send = $request->time_to_send[$rem_k];
                    $cm_obj->offer_id = $request->offer_id[$rem_k];
                    $cm_obj->campaign_id = $camp->id;
                    $cm_obj->send_by = $request->send_by[$rem_k];
                    $cm_obj->hours_to_send = $request->hours_to_send[$rem_k];
                    $cm_obj->mins_to_send = $request->mins_to_send[$rem_k];
                    $cm_obj->save();
                    array_push($respose['fol_id'],$cm_obj->id);
                }
            }
            }
            $respose["success"] = true;
            $respose["camp_id"] = $camp->id;
            echo json_encode($respose);
        }else
        {
            echo '{"success":false,"error":"error while saving campaign"}';
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $Group = Group::where("user_id",Auth::User()->id)->get();
        $camp = Campaign::find($id);
        if($camp->user_id!=Auth::User()->id)
        {
            return redirect("campaigns");
        }
        $offers = Offer::where("user_id",Auth::User()->id)->get();
        return view("admin.campaign.create",["groups"=>$Group,"offers"=>$offers,"data"=>$camp]);
       // return view("admin.campaign.create",["groups"=>$Group,"data"=>$camp]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
     /**
     * SmsControlling.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function SmsCon(Request $request)
    {
        if(!isset($_REQUEST['echo']))
        {
            header('Content-Type: text/xml');
            echo "<Response></Response>";
        }
        $Body 			= trim($request->Body);
        $SmsSid			= @$request->SmsMessageSid;
        $From 			= $request->From;
        $To				= $request->To;
        $req_data       = $request->all();
        if(strtolower($Body)=='stop')
        {
            Contact::where("phone",$From)->update(["status"=>0,"unsub_date"=>Carbon::now('UTC')->format("Y-m-d H:i")]);
        }
        
        if(strtolower($Body)=='start')
        {
            Contact::where("phone",$From)->update(["status"=>1]);
        }
        
        $service_id = ServicePhone::where("phone_number",$To)->value('sms_service_id');
       $service =  SmsService::find($service_id);
        $chat = new Chat;
        $chat->user_id = ($service)?$service->user_id:'';
        $chat->send_to = $To;
        $chat->send_from = $From;
        $chat->sms_sid = $SmsSid;
        $chat->body = $Body;
        $chat->direction = "inbound";
        $chat->status = "received";
        $chat->msg_type = "chat";
        $chat->is_read = 0;
        $chat->save();
    }
    
    public function getError($sid,$user_id)
    {
        $setting = Setting::where("user_id",$user_id)->first();
        $url = "https://$setting->twilio_sid:$setting->twilio_token@api.twilio.com/2010-04-01/Accounts/$setting->twilio_sid/Messages/$sid.json";
        $ch = curl_init(); // Initialize the curl
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_URL, $url);  // set the opton for curl
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);// set the option to transfer output from script to curl
       // curl_setopt($ch, CURLOPT_POST, 1);
        //curl_setopt($ch, CURLOPT_POSTFIELDS, $val);
        $response = curl_exec($ch);
        curl_close($ch);

        return $response;
    }
    
     public function SmsStatuscallback(Request $request)
    {
      // mail("unique.munda7@gmail.com","SMS Status",print_r($request->all(),true));
       $his =   Chat::where('sms_sid',$request->SmsSid)->first();
       if($his)
       {
           // $res = $this->getError($request->SmsSid,$his->user_id);
           $error_messge = "uknown error message";
           $data = json_decode(file_get_contents("https://twilio-cms-prod.s3.amazonaws.com/documents/twilio-error-codes.json"),true);
           $ids = array_search('21610', array_column($data, 'code')); 
           if($ids!='')
           {
            $error_messge =  $data[$ids]['message'];
           }
            //echo 
            //$data = json_decode($res);
            $his->status = $request->MessageStatus;
            $his->send_from = $request->From;
            $his->error = $error_messge;
            $his->save();
       }
       return "";
    }
    
    public function listCamps(Request $request)
    {
        $data = Campaign::select(['id','name','status','created_at'])->where('user_id',Auth::user()->id);
		return Datatables::of($data)
		->addColumn('action',function($d){
		  $edit_url = url("/campaigns/$d->id/edit");
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
            <a class='dropdown-item' href='$edit_url'><i class='la la-edit'></i> Edit</a> 
            <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
            </div>
            </span>";
                        
            return $cc;
		})
      
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        
        
        ->rawColumns(['action'])
        ->make(true);	
    }
    
    public function delcampGroup(Request $request)
    {
        if($request->campaign_id!='')
        {
            CampaignGroup::where("campaign_id",$request->campaign_id)->where("group_id",$request->group_id)->delete();
            echo "1";
        }
        return "";
    }
    
    
    public function newOffer()
    {
        $offers = Offer::where("user_id",Auth::User()->id)->get();
       return view("admin.campaign.followup",["offs"=>$offers]); 
    }
    
    public function delCampaign(Request $request)
    {
      $del =  Campaign::where("id",$request->id)->delete();
      if($del)
      {
        echo "1";
      }else
      {
        echo "0";
      }
      return "";
    }
    
    public function delOffer(Request $request)
    {
        $req = Followup::where("id",$request->id)->delete();
        if($req)
        {
            echo "1";
        }else
        {
            echo "0";
        }
        return "";
    }
    
    public function checkOffer(Request $request)
    {
       return $checkoffer =  Offer::where("offer_id","$request->id")->count();
       
    }
    
    public function reporting()
    {
        $timezone = Setting::where("user_id",Auth::User()->id)->value("timezone");
        $timezone = preg_replace('/\-/', '/', $timezone);
          if($timezone=='' || $timezone==null){
            $timezone = 'America/Chicago';
          }
          //echo $timzon;
          $date = Carbon::now($timezone)->format("Y-m-d");
       // $date =  Carbon::createFromFormat('Y-m-d', , 'UTC')
       // ->setTimezone($timezone);
        $total_unsub_leads = Contact::where("user_id",Auth::User()->id)->where("status",'0')->whereRaw("unsub_date between '$date' and '$date'")->count();
        $accepted = Contact::where("user_id",Auth::User()->id)->where("is_accepted","yes")->whereRaw("DATE(created_at) between '$date' and '$date'")->count();
        $rejected = Contact::where("user_id",Auth::User()->id)->where("is_accepted",'!=',"yes")->whereRaw("DATE(created_at) between '$date' and '$date'")->count();
        
        $msgs_dil = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->where("status","delivered")
        ->whereRaw("DATE(created_at) between '$date' and '$date'")
        ->count();
        return view("admin.reporting.report",[
        "leads"=>array("unsub"=>$total_unsub_leads,"accepted"=>$accepted,"rejected"=>$rejected,"delivered"=>$msgs_dil),
        ]);
    }
    public function lead_report(Request $request)
    {
        $timezone = Setting::where("user_id",Auth::User()->id)->value("timezone");
        $timezone = preg_replace('/\-/', '/', $timezone);
          if($timezone=='' || $timezone==null){
            $timezone = 'America/Chicago';
          }
          //echo $timzon;
          //$date = Carbon::now($timezone)->format("Y-m-d");
       // $date =  Carbon::createFromFormat('Y-m-d', , 'UTC')
       // ->setTimezone($timezone);
        if($request->start!='')
        {
            $total_unsub_leads = Contact::where("user_id",Auth::User()->id)->where("status",'0')->whereRaw("unsub_date between '$request->start' and '$request->end'")->count();
            $accepted = Contact::where("user_id",Auth::User()->id)->where("is_accepted","yes")->whereRaw("DATE(created_at) between '$request->start' and '$request->end' ")->count();
            $rejected = Contact::where("user_id",Auth::User()->id)->where("is_accepted",'!=',"yes")->whereRaw("DATE(created_at) between '$request->start' and '$request->end' ")->count();
            
            $msgs_dil = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->where("status","delivered")
            ->whereRaw("DATE(created_at) between '$request->start' and '$request->end'")
            ->count();
        }else
        {
            $total_unsub_leads = Contact::where("user_id",Auth::User()->id)->where("status",'0')->count();
            $accepted = Contact::where("user_id",Auth::User()->id)->where("is_accepted","yes")->count();
            $rejected = Contact::where("user_id",Auth::User()->id)->where("is_accepted",'!=',"yes")->count();
            
            $msgs_dil = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->where("status","delivered")
            ->count();
        }
       
       return array("unsub"=>$total_unsub_leads,"accepted"=>$accepted,"rejected"=>$rejected,"delivered"=>$msgs_dil);
       
    }
    
    public function fail_report()
    {
        if(isset($_REQUEST['startdate']))
        {
            $data = Chat::select(["chats.*",
            DB::raw("CONCAT(chats.id,'-',chats.send_to) as state")
            ])->where("user_id",Auth::User()->id)->where("direction","outbound")
            ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]' and direction='outbound'")
            ->whereIn("status",["undelivered","failed"]);
            
        }else
        {
            $data = Chat::select(["chats.*",
            DB::raw("CONCAT(chats.id,'-',chats.send_to) as state")
            ])->where("user_id",Auth::User()->id)->where("direction","outbound")->whereIn("status",["undelivered","failed"]);
        }
        return Datatables::of($data)
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        ->editColumn('state',function($d){
           
          return  Contact::where("phone",$d->send_to)->value("state");;
        })
        ->orderColumn('state', function ($query, $order) {
                     $query->orderBy('state', $order);
                 })
        ->make(true);
    }
	
	public function failureexport()
	{
		 header('Content-Type: application/excel');
		header('Content-Disposition: attachment; filename="failreport.csv"');
		$fp = fopen('php://output', 'w');
		$f=array("Reason","To Number","From Number","OfferID","State");
		fputcsv($fp, $f);
		if(isset($_REQUEST['startdate']))
        {
            $data = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")
            ->whereRaw("DATE(created_at) between '$_REQUEST[startdate]' and '$_REQUEST[enddate]' and direction='outbound'")
            ->whereIn("status",["undelivered","failed"])->get();
            
        }else
        {
            $data = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->whereIn("status",["undelivered","failed"])->get();
        }
		foreach($data as $d)
		{
			$a = array();
        $a[] = $d->error;
        $a[] = $d->send_to;
        $a[] = $d->send_from;
        $a[] = $d->offer_id;
        $a[] = Contact::where("phone",$d->send_to)->value("state");
        fputcsv($fp, $a);
		}
		fclose($fp);  
        //die();
        return "";   	
	}
    
}
