<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Setting;
use App\SmsService;
use App\Group;
use App\Contact;
use App\GroupContact;
use App\CampaignGroup;
use App\Chat;
use App\CampaignContact;
use App\Campaign;
use App\Source;
use Yajra\Datatables\Datatables;
use DB;
use Auth;
use DateTime;

class ContactController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $dm =  Group::where("user_id",Auth::User()->id)->get();
       return view("admin.contacts.list",["groups"=>$dm]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $phone = $this->NumberFormat($request->phone);
        $hash = "";
        $c = 1;
        
        $obj = new Contact();
	    if(isset($request->id))
        {
            //updating
            $obj = $obj->findOrFail($request->id);
        }else{
            //creating new
            if(Contact::where("phone",$phone)->count()>0)
            {
                echo "Contact Phone already exists";
                return "";
            }
           
            $obj->user_id = Auth::User()->id;
            //$obj->hash_id = $hash;
        }

        $obj = $obj->fill($request->all());
        $obj->phone = $phone;
        
       
        if($obj->save())
        {  
            
            /*if($request->id=='')
            {
               $gc = new GroupContact;
               $gc->group_id = $request->group_id;
               $gc->contact_id = $obj->id;
               $gc->save();
            }else
            {
                $gp =  GroupContact::where("contact_id",$obj->id)->first();
                $gp->group_id = $request->group_id;
                $gp->save();
            }*/
            if(isset($request->group_id))
            {
                foreach($request->group_id as $grp)
                {
                    if(GroupContact::where("group_id",$grp)->where("contact_id",$obj->id)->count()==0)
                    {
                        
                        $gpc = new GroupContact;
                        $gpc->group_id = $grp;
                        $gpc->contact_id = $obj->id;
                        $gpc->save();
                    }
                }
            }
            
            echo "1";
        }else{
            echo "error while creating contact";
        } 
        return '';
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request,$id='')
    {
        //
        $con = Contact::where("id",$request->id)->first()->toArray();
        $gp = GroupContact::where("contact_id",$request->id)->pluck('group_id')->toArray();
        $con['group_id'] = $gp;
       // $db = (array)$con;
        //print_r($con);
        return $con ;
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
     public function del_contact(Request $request)
    {
      $del =  Contact::where("id",$request->id)->delete();
      if($del)
      {
        echo "1";
      }else
      {
        echo "0";
      }
      return "";
    }
    public function listContacts()
    {
        $data = Contact::leftJoin("group_contacts",'contacts.id', '=', 'group_contacts.contact_id')
        ->leftJoin("groups",'groups.id', '=', 'group_contacts.group_id')
        ->where('contacts.user_id',Auth::user()->id)
        ->select(['contacts.*','groups.name']);
        
		return Datatables::of($data)
		->addColumn('action',function($d){
		 $cc = "<div class='dropdown dropdown-inline'>
          
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='false'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu '>
            <a class='dropdown-item' href='javascript:editFun($d->id)'><i class='la la-edit'></i> Edit</a>
            <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
            </div>
            
         </div>";
                        
            return $cc;
		})
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        ->editColumn("status",function($d){
            if($d->status=='1')
            {
                return '<span class="kt-switch kt-switch--sm kt-switch--icon">
									<label>
									<input value="'.$d->id.'" class="userstatus" type="checkbox" checked="checked" name="">
									<span></span>
									</label>
									</span>';
            }else
            {
                 return '<span class="kt-switch kt-switch--sm kt-switch--icon">
									<label>
									<input value="'.$d->id.'" class="userstatus" type="checkbox"  name="">
									<span></span>
									</label>
									</span>';
            }
        })
        ->addColumn('age',function($d){
            $userage = "";
            if($d->dob!=''){
                $userage =  $this->GetDob($d->dob)." /Y";
            }
            return $userage;
        })
        ->rawColumns(['action','status'])
        ->make(true);	
    }
    public function NumberFormat($number){
        $number = preg_replace('/\D+/', '', $number);

        if (preg_match('/^\d{10}$/', $number)) {
            
            $number =  '+1'.$number;
            // pass
            
        } else{
            
            $number =  '+'.$number;
            //fail
        }
        return $number;
    }
    
    function gen_hash($length)
{
        $token = "";
        $codeAlphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $codeAlphabet.= "abcdefghijklmnopqrstuvwxyz";
        $codeAlphabet.= "0123456789";
        $max = strlen($codeAlphabet) - 1;
        for ($i=0; $i < $length; $i++) {
            $token .= $codeAlphabet[$this->crypto_rand_secure(0, $max)];
        }
        return $token;
}
    
function crypto_rand_secure($min, $max)
{
        $range = $max - $min;
        if ($range < 1) return $min; // not so random...
        $log = ceil(log($range, 2));
        $bytes = (int) ($log / 8) + 1; // length in bytes
        $bits = (int) $log + 1; // length in bits
        $filter = (int) (1 << $bits) - 1; // set all lower bits to 1
        do {
            $rnd = hexdec(bin2hex(openssl_random_pseudo_bytes($bytes)));
            $rnd = $rnd & $filter; // discard irrelevant bits
        } while ($rnd >= $range);
        return $min + $rnd;
}
 
public function GetDob($userDob)
{
    $dob = new DateTime($userDob);
    //$dob->setTimestamp();
    $now = new DateTime();
    $difference = $now->diff($dob);
    $age = $difference->y;
    return $age;
}

public function savehis($uid)
{
    
}

public function sendSms($uid,$to,$from,$msg,$msg_type,$offer_id='')
{
    $Setting  = Setting::where("user_id",$uid)->first();
    
    $TwilioSid = $Setting->twilio_sid;

    $TwilioToken = $Setting->twilio_token;
    $sid = "";

        $url = "https://$TwilioSid:$TwilioToken@api.twilio.com/2010-04-01/Accounts/$TwilioSid/Messages";

        $val = array(

            "To"=>$to,

            "MessagingServiceSid"=>$from,

            "Body"=>$msg,
            
            "StatusCallback"=>url("/sms-status")

        );
        /*if($request->media != ''){

            $val['MediaUrl'] = $request->media ;

        }*/
        $delivery_status = '0';

            $ch = curl_init(); // Initialize the curl

            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

            curl_setopt($ch, CURLOPT_URL, $url);  // set the opton for curl

            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);// set the option to transfer output from script to curl

            curl_setopt($ch, CURLOPT_POST, 1);

            curl_setopt($ch, CURLOPT_POSTFIELDS, $val);

            $response = curl_exec($ch);

            curl_close($ch);

            $check = (array)simplexml_load_string($response);
            // print_r($check);   
            if(!isset($check['RestException'])){

                $delivery_status = '1';

                $sid = $check['Message']->Sid;
                $status = "sent";
                $error = "";
                //return response()->json(["success"=>"true" ], 200);

            }else{
                $status = "failed";
                $error = $check['RestException']->Message;
                //return response()->json(["success"=>"false","msg"=>$check['RestException']->Message], 200);
            }
            $chat = new Chat;
            $chat->user_id = $uid;
            $chat->send_to = $to;
            $chat->send_from = "";
            $chat->sms_sid = $sid;
            $chat->body = $msg;
            $chat->direction = "outbound";
            $chat->status = $status;
            $chat->msg_type = $msg_type;
            $chat->is_read = 1;
            $chat->offer_id = $offer_id;
            $chat->full_response = json_encode($check);
            $chat->error = $error;
            $chat->save();
}

public function sendCampignmsg($cid,$uid,$grps)
{
    //print_r($grps);
    //die();
    $firstgroup =  CampaignGroup::whereIn("group_id",$grps)->pluck("campaign_id");
    //print_r($firstgroup);
    //die();
    if($firstgroup)
    {
        $camp = Campaign::whereIn("id",$firstgroup->toArray())->where("status","live")->first();
        //echo $camp->welcome_msg;
        //die();
        if($camp)
        {
            if($camp->welcome_msg!='')
            {
                $contact = Contact::find($cid);
                $tags = array("%first_name%","%last_name%","%email%","%phone%","%city%","%state%","%zip%","%source%","%brand%");
                $replace = array($contact->first_name,$contact->last_name,$contact->email,$contact->phone,$contact->city,$contact->state,$contact->zip,$contact->source,$contact->brand);
                $msg = str_replace($tags,$replace,$camp->welcome_msg);
                $append_text = Setting::where("user_id",$uid)->value("append_text");
                if($append_text)
                {
                    $msg = $msg." ".$append_text;
                }
                
                $group = Group::find($grps[0]);
                //echo $firstgroup->service_id;
                $service = Smsservice::where("id",$group->service_id)->first();
                //print_r($service);
                if($service)
                {
                    $this->sendSms($uid,$contact->phone,$service->twilio_msg_sid,$msg,"welcome");
                }
                
            }
        }
    }
    
}    
    public function getLead(Request $request)
    {
        $data = $request->all();
        $c = 1;
        if(!isset($request->mytest))
        {
             //die();
        }
       
        //mail("unique.munda7@gmail.com","Test data SAV",print_r($data,true));
        //mail("unique.munda7@gmail.com","Test data SAV false",print_r($data));
        if(!isset($request->Phone1) || $request->Phone1=='')
        {
            echo '{"error":"Phone param is required"}';
            return "";
        }
        
        if(!isset($request->Email) || $request->Email=='')
        {
            echo '{"error":"Email param is required"}';
            return "";
        }
        
        if(!isset($request->State) || $request->State=='')
        {
            echo '{"error":"State param is required"}';
            return "";
        }
        /*if(!isset($request->DOB) || $request->DOB=='')
        {
            //echo '{"error":"DOB param is required"}';
           // return "";
        }*/
        $hash = "";
        while($c==1)
        {
            $hash = $this->gen_hash(5);
            if(Contact::where("user_id",$request->uid)->where("hash_id",$hash)->count()==0)
            {
                break;
            }
        }
        
        $phone = $this->NumberFormat($request->Phone1);
        /*if(isset($request->DOB) && $request->DOB!='')
        {
            $userage =  $this->GetDob($request->DOB);
            $groups = Group::whereRaw("'$userage' BETWEEN age_from and age_to")->where("user_id",$request->uid)->get();
        }*/
        if(isset($request->Source) && $request->Source!='')
        {
            $source = Source::where("name",$request->Source)->first();
            if($source)
            {
                $groups = Group::whereRaw("FIND_IN_SET($source->id,sources)")->where("user_id",$request->uid)->get();
            }else
            {
                 $groups = Group::whereRaw("age='noage'")->where("user_id",$request->uid)->get();
            }
             
        }
        else
        {
            $groups = Group::whereRaw("age='noage'")->where("user_id",$request->uid)->get();
        }
         
        //var_dump($groups);
        //die();
        if(count($groups)==0)
        {
            $contact = new Contact;
            $contact->user_id = $request->uid;
            $contact->hash_id = $hash;
            $contact->first_name = @$request->Fname;
            $contact->last_name = @$request->Lname;
            $contact->email = @$request->Email;
            $contact->phone = $phone;
            $contact->city = @$request->City;
            $contact->state = @$request->State;
            $contact->zip = @$request->Zip;
            $contact->source = @$request->Source;
            $contact->brand = @$request->Brand;
            $contact->tfcert = @$request->TFCert;
            $contact->dob = @$request->DOB;
            $contact->notes = @$request->Notes;
            $contact->campaign = @$request->Campaign;
            $contact->is_accepted = 'no';
            if($contact->save())
            {
                
            }
            echo '{"error":"Group not found aganist the Source parameter"}';
            //echo '{"error":"Group not found aganist the DOB parameter"}';
            return "";
        }
       
        $contact = Contact::where("phone",$phone)->where("user_id",$request->uid)->first();
        if($contact)
        {
            $grps = array();
            foreach($groups as $grp)
            {
                if(GroupContact::where("group_id",$grp->id)->where("contact_id",$contact->id)->count()==0)
                {
                    $grps[] = $grp->id;
                    $gpc = new GroupContact;
                    $gpc->group_id = $grp->id;
                    $gpc->contact_id = $contact->id;
                    $gpc->save();
                }
            }
            $this->sendCampignmsg($contact->id,$request->uid,$grps);
            //;
             echo "done2";
        }else
        {
            $contact = new Contact;
            $contact->user_id = $request->uid;
            $contact->hash_id = $hash;
            $contact->first_name = @$request->Fname;
            $contact->last_name = @$request->Lname;
            $contact->email = @$request->Email;
            $contact->phone = $phone;
            $contact->city = @$request->City;
            $contact->state = @$request->State;
            $contact->zip = @$request->Zip;
            $contact->source = @$request->Source;
            $contact->brand = @$request->Brand;
            $contact->tfcert = @$request->TFCert;
            $contact->dob = @$request->DOB;
            $contact->notes = @$request->Notes;
            $contact->campaign = @$request->Campaign;
            if($contact->save())
            {
               /* $gpc = new GroupContact;
                $gpc->group_id = $group->id;
                $gpc->contact_id = $contact->id;
                $gpc->save();*/
                //print_r($groups->toArray());
                $grps = array();
                foreach($groups as $grp)
                {
                    //echo $grp->id;
                    if(GroupContact::where("group_id",$grp->id)->where("contact_id",$contact->id)->count()==0)
                    {
                        $grps[] =$grp->id; 
                        $gpc = new GroupContact;
                        $gpc->group_id = $grp->id;
                        $gpc->contact_id = $contact->id;
                        if($gpc->save())
                        {
                          //  echo "grp save";
                        }
                    }
                }
                echo $this->sendCampignmsg($contact->id,$request->uid,$grps);
            }
            echo "done1";
            return "";
        }
        /*$cons = Contact::where("phone",$phone)->where("user_id",$request->uid)->count();
        $gc = GroupContact::where("group_id",$group->id)->where("contact_id",$contact->id)->count(); 
       // die();
        if($gc==0 && $cons==0)
        {
            
        }*/
        
        //print_r($request->all());
        return "";
    }
    
    public function savehash()
    { $c = 1;
        $cons = Contact::all();
        foreach($cons as $con)
        {
            $hash = "";
        while($c==1)
        {
            $hash = $this->gen_hash(5);
            if(Contact::where("hash_id",$hash)->count()==0)
            {
                break;
            }
        }
            $con->hash_id = $hash;
            $con->save();
        }
        
    }
    
   public function del_contact_group(Request $request)
    {
        if($request->contact_id!='')
        {
            GroupContact::where("contact_id",$request->contact_id)->where("group_id",$request->group_id)->delete();
            echo "1";
        }
        return "";
    }
    
    public function conStatus(Request $request)
    {
        
            Contact::where("id",$request->id)->update(["status"=>$request->status]);
       
    }
    
    public function import_contacts(Request $request)
    {
        
        $settings = Setting::where('user_id',Auth::User()->id)->first();
        
        $timezone_val = $settings->timezone;
        $timezone = preg_replace('/\-/', '/', $timezone_val);
        if($timezone_val=='' || $timezone_val==null){
            $timezone = 'America/Chicago';
        }
        date_default_timezone_set($timezone);
         //print_r($_FILES);
        //die();
        
        if(!$request->file('con_csv'))
        {
            $image_fail = true;
            $respose['error'] = "true";
           //print_r($error);
            //echo $error->first('form_logo');
            $respose['msg'] = "You must need to select a csv file";
            
            echo json_encode($respose);
            return "";
            
        }
       
        else
        {
            $image_fail = true;
            $file = $request->file('con_csv');
            $ext = $file->getClientOriginalExtension();
            $field_arr = array();
            if($ext!="csv")
            {
                $image_fail = true;
                $respose['error'] = "true";
               //print_r($error);
                //echo $error->first('form_logo');
                $respose['msg'] = "Only CSV allowed to upload";
                echo json_encode($respose);
                return "";
            }
            
            
            $file = fopen($_FILES['con_csv']['tmp_name'],"r");
            $data1 = fgetcsv($file);
            /*if(count($data1)<5)
            {
                $respose['error'] = "true";
                $respose['msg'] = "File format is not correct.Fields order should be name,email,phone,birthday,anniversary,custom1,custom2";
                echo json_encode($respose);
                return "";
            }*/
            if($request->import_step=="1"){
                $response = array("import_step"=>"1","csv_fields"=>$data1);
                echo json_encode($response);
                die();
            }
            
             $i=1;
           // while(! feof($file))
           
            $status = 0;
            //print_r($dp_data);
           //die();
          while (($data = fgetcsv($file)) !== FALSE)
            {
                
                //print_r($data);
              // continue;
                    /*if($i==1)
                    {
                        ++$i;
                        continue;
                    }*/
                        $ff = $data;
                       // print_r($ff);
                        ///die();
                        $ph = "";
                        $name_col = $_REQUEST['field']['name'];
                        $lname_col = $_REQUEST['field']['last_name'];
                        $phn_col = $_REQUEST['field']['phone'];
                        $email_col = $_REQUEST['field']['email'];
                        $city_col = $_REQUEST['field']['city'];
                        $state_col = $_REQUEST['field']['state'];
                        $zip_col = $_REQUEST['field']['zip'];
                       // echo $ff[$phn_col];
                       // die();
                        
                       $ph = $this->NumberFormat($ff[$phn_col]);
                       $email = $ff[$email_col];
                       
                      // echo "<br>";
                        // continue;
                        
                            $find = Contact::where("phone",$ph)->first();
                            if($find)
                            {
                                $find = GroupContact::where("group_id",$request->imp_group_id)->where("contact_id",$find->id)->count();
                            }
                                                        
                           
                       //continue;
                        //print_r($ff)."/$find";
                        if($find==0)
                        {
                            $sub = new Contact();
                            if(isset($ff[$name_col]))
                            $sub->first_name = mb_convert_encoding($ff[$name_col], 'UTF-8', 'UTF-8');
                            if(isset($ff[$lname_col]))
                            $sub->last_name = mb_convert_encoding($ff[$lname_col], 'UTF-8', 'UTF-8');
                            
                             //if(isset($ff[$email_col]))
                             $sub->email = $email;
                            
                             if(isset($ff[$phn_col]))
                             {
                                $sub->phone = mb_convert_encoding($ph, 'UTF-8', 'UTF-8');
                             }
                            
                                if(isset($ff[$city_col]) && $ff[$city_col]!='')
                                $sub->city = mb_convert_encoding($ff[$city_col], 'UTF-8', 'UTF-8');
                            
                                if(isset($ff[$state_col]) && $ff[$state_col]!='')
                                $sub->state = mb_convert_encoding($ff[$state_col], 'UTF-8', 'UTF-8');
                                
                                if(isset($ff[$zip_col]) && $ff[$zip_col]!='')
                                $sub->zip = mb_convert_encoding($ff[$zip_col], 'UTF-8', 'UTF-8');
                            
                                $sub->user_id = Auth::User()->id;
                                
                                if($sub->save())
                                {
                                        $gpc = new GroupContact;
                                        $gpc->group_id = $request->imp_group_id;
                                        $gpc->contact_id = $sub->id;
                                        $gpc->save();
                                }
                         }
                       // print_r(fgetcsv($file));
                    
                    
                    
                    
                    ++$i;
            }
            
                fclose($file);
                //die();
                echo "1";
        }
    }
}
