<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Setting;
use App\ServicePhone;
use App\Group;
use App\SmsService;
use App\Campaign;
use App\CampaignGroup;
use App\Offer;
use App\Contact;
use App\OfferStat;
use App\Followup;
use App\Chat;
use Auth;
use DB;
use Yajra\Datatables\Datatables;
class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
     public $state_list = array(array('state'=>"AL","cnt"=>0),  
    array('state'=>"AK","cnt"=>0),  
    array('state'=>"AZ","cnt"=>0),  
    array('state'=>"AR","cnt"=>0),  
    array('state'=>"CA","cnt"=>0),  
    array('state'=>"CO","cnt"=>0),  
    array('state'=>"CT","cnt"=>0),  
    array('state'=>"DE","cnt"=>0),  
    array('state'=>"DC","cnt"=>0),  
    array('state'=>"FL","cnt"=>0),  
    array('state'=>"GA","cnt"=>0),  
    array('state'=>"HI","cnt"=>0),  
    array('state'=>"ID","cnt"=>0),  
    array('state'=>"IL","cnt"=>0),  
    array('state'=>"IN","cnt"=>0),  
    array('state'=>"IA","cnt"=>0),  
    array('state'=>"KS","cnt"=>0),  
    array('state'=>"KY","cnt"=>0),  
    array('state'=>"LA","cnt"=>0),  
    array('state'=>"ME","cnt"=>0),  
    array('state'=>"MD","cnt"=>0),  
    array('state'=>"MA","cnt"=>0),  
    array('state'=>"MI","cnt"=>0),  
    array('state'=>"MN","cnt"=>0),  
    array('state'=>"MS","cnt"=>0),  
    array('state'=>"MO","cnt"=>0),  
    array('state'=>"MT","cnt"=>0),
    array('state'=>"NE","cnt"=>0),
    array('state'=>"NV","cnt"=>0),
    array('state'=>"NH","cnt"=>0),
    array('state'=>"NJ","cnt"=>0),
    array('state'=>"NM","cnt"=>0),
    array('state'=>"NY","cnt"=>0),
    array('state'=>"NC","cnt"=>0),
    array('state'=>"ND","cnt"=>0),
    array('state'=>"OH","cnt"=>0),  
    array('state'=>"OK","cnt"=>0),  
    array('state'=>"OR","cnt"=>0),  
    array('state'=>"PA","cnt"=>0),  
    array('state'=>"RI","cnt"=>0),  
    array('state'=>"SC","cnt"=>0),  
    array('state'=>"SD","cnt"=>0),
    array('state'=>"TN","cnt"=>0),  
    array('state'=>"TX","cnt"=>0),  
    array('state'=>"UT","cnt"=>0),  
    array('state'=>"VT","cnt"=>0),  
    array('state'=>"VA","cnt"=>0),  
    array('state'=>"WA","cnt"=>0),  
    array('state'=>"WV","cnt"=>0),  
    array('state'=>"WI","cnt"=>0),  
    array('state'=>"WY","cnt"=>0));
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        
        $total_leads = Contact::where("user_id",Auth::User()->id)->count();
        $total_act_leads = Contact::where("user_id",Auth::User()->id)->where("status",'1')->count();
        $total_unsub_leads = Contact::where("user_id",Auth::User()->id)->where("status",'0')->count();
        $msgs = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->count();
        $msgs_dil = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->where("status","delivered")->count();
        $msgs_fail = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->where("status","failed")->orWhere("status","undelivered")->count();
        $msgs_sent = Chat::where("user_id",Auth::User()->id)->where("direction","outbound")->where("status","sent")->orWhere("status","queued")->count();
        $user_id = Auth::User()->id;
        //$user_id = 2;
        
           // print_r($offer_delivery_rate);
           // die();
        /**Offer stats **/
       
       
        return view('admin.home',[
        "leads"=>array("total"=>$total_leads,"active"=>$total_act_leads,"unsub"=>$total_unsub_leads),
        "msg"=>array("total"=>$msgs,"sent"=>$msgs_sent,"fail"=>$msgs_fail,"delivered"=>$msgs_dil)]);
    }
    
    public function NumberStats(Request $request)
    {
        //SELECT count(1) as send from chats where user_id=1 and direction='outbound' and status='delivered' and send_from in (SELECT phone_number FROM `service_phones`)
      // $service_ids =  SmsService::where("user_id",Auth::User()->id)->pluck('id');
       //$phones = ServicePhone::whereIn("sms_service_id",$service_ids)->pluck('phone_number');
       $del = Chat::where("send_from",$request->number)->where("direction","outbound")->where("status","delivered")->count();
       $fail = Chat::where("send_from",$request->number)->where("direction","outbound")->whereRaw("(status='failed' or status='undelivered')")->count();
       $queue = Chat::where("send_from",$request->number)->where("direction","outbound")->where("status","queued")->count();
       $total = Chat::where("send_from",$request->number)->where("direction","outbound")->count();
       return ["queue"=>$queue,"fail"=>$fail,"delivered"=>$del,"total"=>$total];
    }
    
    public function offerStats(Request $request)
    {
        $total_clicks = OfferStat::where("offer_id",$request->id)->count();
        $unique_clicks = OfferStat::where("offer_id",$request->id)->groupBy("contact_id")->get()->count();
       // $unique_clicks = DB::select("SELECT sum(count) as cnt FROM (SELECT COUNT(*) AS count FROM offer_stats where `offer_id` = '$request->id' GROUP by contact_id HAVING count >= 1) as A");
        $delivered = Chat::where("offer_id",$request->id)->where("status","delivered")->count();
        $sent = Chat::where("offer_id",$request->id)->where("direction","outbound")->count();
        return ["total_click"=>$total_clicks,"unique_click"=>$unique_clicks,"sent"=>$sent,"delivered"=>$delivered];
    }
    
    public function failedMsgs(Request $request)
    {
        return view("admin.contacts.failed",[]);
    }
    
    public function failedMsgslist(Request $request)
    {
        $data = Chat::where("user_id",Auth::User()->id)->whereIn("status",["undelivered","failed"]);
        return Datatables::of($data)
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        ->make(true);	
    }
    
    public function stateFilter(Request $request)
    {
        $user_id = Auth::User()->id;
        $state_cons =  DB::select("SELECT state,count(1) as cnt FROM `contacts` where user_id=$user_id and created_at between '$request->startdate' and '$request->enddate' GROUP BY state");
        if(count($state_cons)==0)
           {
            $state_cons = $this->state_list;
           }
           
           return ["state_cons" => $state_cons];
    }
    
    public function offer_filter(Request $request)
    {
        $user_id = Auth::User()->id;
        
        $offer_sent = DB::select("SELECT offer_id,count(1) as cnt FROM `chats` where offer_id in(SELECT offer_id from offers where user_id=$user_id) and direction='outbound' and created_at between '$request->startdate' and '$request->enddate' GROUP by offer_id");
            
            $offer_total_count = [];
            if(count($offer_sent)>0)
            {
                foreach($offer_sent as $snt)
                {
                    
                    $offer_total_count[$snt->offer_id] = $snt->cnt;
                }
            }
        
        $offer_delivered = DB::select("SELECT offer_id,count(1) as cnt FROM `chats` where offer_id in(SELECT offer_id from offers where user_id=$user_id) and direction='outbound' and status='delivered' and created_at between '$request->startdate' and '$request->enddate' GROUP by offer_id");
            
            $offer_delv_count = [];
            if(count($offer_delivered)>0)
            {
                foreach($offer_delivered as $snt1)
                {
                   
                    $offer_delv_count[$snt1->offer_id] = $snt1->cnt;
                }
            }
           // print_r($offer_delv_count);
            $offer_delivery_rate = [];
            if(count($offer_total_count)>0)
            {
                foreach($offer_total_count as $offerid=>$tcount)
                {
                    if(isset($offer_delv_count[$offerid]))
                    {
                        $offer_delivery_rate[$offerid] = $offer_total_count[$offerid]/$offer_delv_count[$offerid];
                    }
                    
                }
            }
            
            $offer_clicks = DB::select("SELECT offer_id,count(1) as cnt FROM `offer_stats` where offer_id in(SELECT offer_id from offers where user_id=$user_id) and created_at between '$request->startdate' and '$request->enddate' GROUP by offer_id");
            $offer_click_count = [];
            if(count($offer_clicks)>0)
            {
                foreach($offer_clicks as $clicks)
                {
                       $offer_click_count[$clicks->offer_id] = $clicks->cnt;

                }
            }
            $offer_click_rate = [];
            if(count($offer_click_count)>0)
            {
                foreach($offer_click_count as $offeriD=>$ccount)
                {
                    if(isset($offer_delv_count[$offeriD]))
                    {
                        $offer_click_rate[$offeriD] = $offer_click_count[$offeriD]/$offer_delv_count[$offeriD];
                    }
                }
            }
            $offer_stats = [];
            if(count($offer_total_count)>0)
            {
                foreach($offer_total_count as $offer_id=>$count)
                {
                    //echo $offer_id;
                    $offer_stats[] = array(
                    "offer"=>$offer_id,
                    "sent"=>$count,
                   // "delivered"=>isset($offer_delivery_rate[$offer_id])?$offer_delivery_rate[$offer_id]:0,
                   // "clicks"=>isset($offer_click_rate[$offer_id])?$offer_click_rate[$offer_id]:0
                    "delivered"=>isset($offer_delv_count[$offer_id])?$offer_delv_count[$offer_id]:0,
                    "clicks"=>isset($offer_click_count[$offer_id])?$offer_click_count[$offer_id]:0
                    );
                }
            }
         return ["offer_cons"=>$offer_stats];  
    }
}
