<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Setting;
use App\User;
use App\ServicePhone;
use App\SmsService;
use App\CallHistory;
use App\CallRecording;
use Auth;
use Yajra\Datatables\Datatables;

class SettingController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
       
    } 
     
    public function index()
    {
		$timezones  = TimeZoneController::getTimeZones();
        $twilio = new TwilioController();
        $number = $twilio->getNumbers();
        $obj    = Setting::where('user_id','=',Auth::User()->id)->first();
       return view('admin.setting.setting',['timezones'=>$timezones,"number"=>$number,"data"=>$obj]);
    }
 

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
		return redirect('/settings');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
     
    public function NumberFormat($number){
       $number = preg_replace('/\D+/', '', $number);

       if (preg_match('/^\d{10}$/', $number)) {
           
           $number =  '+1'.$number;
           // pass
           
       } else{
           
           $number =  '+'.$number;
           //fail
       }
       return $number;
   } 
     
    public function store(Request $request)
    {
       $obj = new Setting();
	    if(isset($request->id))
        {
            //updating
            $obj = $obj->findOrFail($request->id);
        }else{
            //creating new
            $obj->user_id = Auth::User()->id;
        }

        $obj = $obj->fill($request->all());
        $obj->forward_num = $this->NumberFormat($request->forward_num);
        //if($request->twilio_number!="" && $request->twilio_number!="Select Number")
//        {
//                $num = explode('|',$request->twilio_number);
//                $obj->twilio_number = $num[1];
//        }else
//        {
//            $obj->twilio_number = '';
//        }
        if(isset($request->call_record))
        {
           $obj->call_record = "yes"; 
        }else
        {
            $obj->call_record = "no"; 
        }
        
        if($obj->save())
        {  
            $cc = array("SmsUrl"=>url('/sms/controlling'));
            //if($request->twilio_number!="" && $request->twilio_number!="Select Number")
            //{
               // TwilioController::set_num_url_ci($cc,$num[0],$request->twilio_sid,$request->twilio_token);
            //}
            echo "1";
            //$return = redirect('/settings')->with('success','Saved Successfully.');
        }else{
            echo "0";
            //$return = redirect('/settings')->with('error','Something went wrong. Please reload the page and try again!.');
        } 
        return '';
    }
    
    public function update_voice_url(Request $request)
    {
        $twilio = new TwilioController();
        if($request->sid!="" && $request->token)
        {
            $url = "https://$request->sid:$request->token@api.twilio.com/2010-04-01/Accounts/$request->sid/IncomingPhoneNumbers.json?PageSize=100";
            $res = $twilio->Curl($url,'','get');
            $number = json_decode($res);
            $cc = array("VoiceUrl"=>url('/voice/controlling'));
             if(isset($number->incoming_phone_numbers))
             {
                foreach($number->incoming_phone_numbers as $num)
                {
                    $set_url = $twilio->set_num_url_ci($cc,$num->sid,$request->sid,$request->token);
                }
             } 
             echo "1";
          
        }
    }
    
    public function voiceCon(Request $request)
    {
        header('content-type: text/xml');
        
        $setting = Setting::where('id','1')->value('forward_num');
        
        ?>
          
        <Response>
           <Dial CallerId='<?php $_REQUEST['From']?>'><?php echo $setting;?></Dial>
        </Response>
          
        <?php
        
        return '';
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
       //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }
    
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    
    public function profile()
    {
        return view("admin.profile.profile",[]);
    }
    
    public function saveProfile(Request $request)
    {
        $user = User::find($request->id);
        $user->name = $request->name;
        $user->email = $request->email;
        $user->phone = $request->phone;
        if($request->newpassword!='')
        {
            $user->password = bcrypt($request->newpassword);
        }
        if($user->save())
        {
            
            echo "1";
        }
        else
        {
            echo "0";
        }
        return "";
    }
    
    public function CallCon(Request $request)
    {
        header("content-type:text/xml");
       
        echo "<Response>";
        $phone = ServicePhone::where("phone_number",$request->To)->first();
        if($phone)
        {
            $service = SmsService::where("id",$phone->sms_service_id)->first();
            if($service)
            {
                $calHis =  new CallHistory;
                $calHis->from_num = $request->From;
                $calHis->to_num = $request->To;
                $calHis->call_sid = $request->CallSid;
                $calHis->user_id = $service->user_id;
                $calHis->forward_to = ($service->forward_phone!='')?$service->forward_phone:'none'; 
                $calHis->save();
                //$setting = Setting::where("user_id",$service->user_id)->first();
                if($service->forward_phone!='')
                {
                    ?>
                    
                       <Dial CallerId='<?php $_REQUEST['From']?>'><?php echo $service->forward_phone;?></Dial>
                   
                    <?php
                    
                }
                else
                {
                    //if($service->call_greetings!='')
                    if($service->call_mp3!='')
                     {
                    ?>
                            <Play><?php echo url('/callmp3')."/$service->call_mp3" ?></Play>
                        
                            <?php
                    }
                            
                            if($service->call_record=='yes')
                            {
                                ?>
                                <Record action='<?php echo url('call-recording-post') ?>' timeout="5" finishOnKey="*" maxLength="30"  />
                                <?php
                            }
                                ?>
                    <?php
                    
                }
                
            }
        }
        echo "</Response>";
        return "";
    }
    
    public function handleRecording(Request $request)
    {
        header("content-type: text/xml");
        $record = new CallRecording;
        $record->recording = $request->RecordingUrl;
        $record->call_sid = $request->CallSid;
        $record->save();
        ?>
         <Response>
            <Say>Thanks for your recording.</Say>
            <Hangup />
        </Response>
        <?php
        return "";
    }
    
    public function CallHistorylist()
    {
        
        $data = CallHistory::leftJoin("call_recordings",'call_history.call_sid', '=', 'call_recordings.call_sid')
        ->where('call_history.user_id',Auth::user()->id)
        ->select(['call_history.*','call_recordings.recording']);
        
		return Datatables::of($data)
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        ->editColumn('recording',function($d){
            if($d->recording!='')
            {
          return "<audio controls>
              <source src='$d->recording' type='audio/ogg'>
            Your browser does not support the audio element.
            </audio>";
            }
           return ''; 
        })
        ->addColumn('action',function($d){
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
            <a class='dropdown-item' href='javascript:deleteFun($d->id)'><i class='la la-trash'></i> Delete</a> 
            </div>
            </span>";
                        
            return $cc;
		})
        ->rawColumns(['recording','action'])
        ->make(true);	
    }
    
    public function CallHistory()
    {
        return view("admin.setting.callhistory",[]);
    }
    
    public function DelRecordig(Request $request)
    {
          $del =  CallHistory::where("id",$request->id)->delete();
          if($del)
          {
            echo "1";
          }else
          {
            echo "0";
          }
          return "";
    }
}
