<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;


use App\Setting;
use App\ServicePhone;
use App\SmsService;
use App\Chat;
use App\OfferStat;
use Auth;
use Yajra\Datatables\Datatables;
use Illuminate\Support\Facades\Validator;
use App\Source;
use App\User;
use DB;

class SourceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view("admin.sources.list");
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        
        $obj = new Source;
        $user = new User();
        if($request->id!='')
        {
            $obj = $obj->findorFail($request->id);
            
            $user = $user->findorFail($request->user_id);
        }else
        {
            
            if(User::where("email",$request->email)->count()>0)
            {
                echo "2";
                return "";
            }
            if(Source::where("name",$request->name)->count()>0)
            {
                echo "3";
                return "";
            }
        }
        $user->fill($request->all());
        $user->name = $request->fname;
        $user->last_name = $request->lname;
        $user->email = $request->email;
        $user->password = bcrypt("temp1234");
        $user->user_type = "source"; 
        if($user->save())
        {
            $obj->fill($request->all());
            $obj->create_by = Auth::User()->id;
            $obj->user_id = $user->id;
            $obj->office_phone =$request->phone;
            if($obj->save())
            {
                echo "1";
            }else
            {
                echo "0";
            }
        }else
        {
            echo "0";
        }
        
        return ""; 
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Request $request,$id='')
    {
       return  User::join("sources","users.id","=","sources.user_id")
        ->where("users.id",$request->id)
        ->where("sources.user_id",$request->id)
        ->select(["sources.*","users.name as fname","users.last_name as lname","users.email"])
        ->first();
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    
    public function listSource(Request $request)
    {
     
        $data = Source::leftJoin("users","users.id","=","sources.user_id")->
        
        where('sources.create_by',Auth::user()->id)
        ->select("sources.*","users.email");
    
		return Datatables::of($data)
		->addColumn('action',function($d){
		 $cc = "<span class='dropdown'>
            <a href='#' class='btn btn-sm btn-clean btn-icon btn-icon-md' data-toggle='dropdown' aria-expanded='true'>
            <i class='fa fa-ellipsis-h'></i></a>
            <div class='dropdown-menu dropdown-menu-right'>
            <a class='dropdown-item' href='javascript:editFun($d->user_id)'><i class='la la-edit'></i> Edit</a>
            <a class='dropdown-item' href='javascript:deleteFun($d->user_id)'><i class='la la-trash'></i> Delete</a> 
            </div>
            </span>";
                        
            return $cc;
		})
      
        ->editColumn('created_at',function($d){
          return $d->created_at;
        })
        
        
        ->rawColumns(['action'])
        ->make(true);
     
        
    }
    
    public function delSource(Request $request)
    {
        $del = User::where("id",$request->id)->delete();
        if($del)
        {
            echo "1";
        }else
        {
            echo "0";
        }
        return "";
    }
     
	
}
