<?php

namespace App\Http\Controllers;
use App\Http\Controllers\Controller;

use Illuminate\Http\Request;
use App\Setting;
use App\smsTemplate;
use App\Group;
use App\BroadcastSmsHistory;
use App\SmsService;
use Auth;
use App\CampaignAssign;
use App\Campaign;
use Yajra\Datatables\Datatables;
use DB;

class TwilioController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */

    protected $TwilioSid,$TwilioToken,$user_id,$settings;
    protected $usa = "Y/m/d", $uk = "d/m/Y", $aus = "m/d/Y";
    
    public function __construct()
    {
        if(isset(Auth::User()->id))
        {
            $user_id = Auth::User()->id;
 
            $settings = Setting::where('user_id',$user_id)->first();
            if($settings)
            {
                $this->TwilioSid = $settings->twilio_sid;
                $this->TwilioToken = $settings->twilio_token;
            }
            
        }
    }
    
  
  
    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function getNumbers()
    {
        
         $url = "https://$this->TwilioSid:$this->TwilioToken@api.twilio.com/2010-04-01/Accounts/$this->TwilioSid/IncomingPhoneNumbers.json?PageSize=1000";
        $res = $this->Curl($url,'','get');
        return $res;
    }
    public static function set_num_url_ci($val,$num_sid,$TwilioSid,$TwilioToken) //AT TIME OF CLIENT CREATION IN ADMIN SIDE
    {
        //self::__construct();
        //print_r($val);
        $obj = new TwilioController();
        //echo $num_sid;
        
        $url = "https://$TwilioSid:$TwilioToken@api.twilio.com/2010-04-01/Accounts/$TwilioSid/IncomingPhoneNumbers/$num_sid.json";
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
        curl_setopt($ch, CURLOPT_POSTFIELDS,$val);
         $response = curl_exec($ch);
        curl_close($ch);
        //return $response;
    }
  public function Curl($url,$body,$method)
    {
        
            if(is_array($body))
            $body=http_build_query($body); 
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url );
            //curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 100);
            //curl_setopt($ch, CURLOPT_TIMEOUT, 100);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true );
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            //curl_setopt($ch, CURLOPT_PUT, true );
            if($method == "post")
            curl_setopt($ch, CURLOPT_POST, true );
            if($method == "get")
            curl_setopt($ch, CURLOPT_HTTPGET, true ); 
            if($method=="put")
            {
                 curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
            }     
            if($method=="delete")
            {
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
            }
            //curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
        
            //curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
        
            if($body!="")
        
            curl_setopt($ch, CURLOPT_POSTFIELDS, $body);
        
            //curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        
            $filecontents=curl_exec($ch);
        
            curl_close($ch);
        
            return $filecontents;

    }
    
  
    
    public function send_sms($To,$from,$body,$user_id="")
    {
        if($user_id!="")
        {
            if(User::where("id",$user_id)->value("type")=="sub")
            {
                $settings = Client::where('user_id',$user_id)->first();
                $this->TwilioSid = $settings->twilio_sid;
                $this->TwilioToken = $settings->twilio_token;
            }
            else
            {
                $settings = Setting::where('user_id',$user_id)->first();
                $this->TwilioSid = $settings->twilio_sid;
                $this->TwilioToken = $settings->twilio_token;
            }
        }
       // echo $To,$from,$body;
        //echo "<br>$user_id<br>";
        

         $url = "https://$this->TwilioSid:$this->TwilioToken@api.twilio.com/2010-04-01/Accounts/$this->TwilioSid/Messages";
        $val = array(
            "To"=>$To,
            "From"=>$from,
            "Body"=>$body
        );
        
        $ch = curl_init(); // Initialize the curl
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_URL, $url);  // set the opton for curl
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);// set the option to transfer output from script to curl
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $val);
        $response = curl_exec($ch);
        curl_close($ch);

        return $response;
    }

    public function getNums(Request $request) //AT TIME OF CLIENT CREATION IN ADMIN SIDE
    {
        $used_num = array();
        $did_num = array();
        if($request->sid!="" && $request->token)
        {
            $url = "https://$request->sid:$request->token@api.twilio.com/2010-04-01/Accounts/$request->sid/IncomingPhoneNumbers.json?PageSize=100";
            $res = $this->Curl($url,'','get');
            $number = json_decode($res);
            ?>
            <option value=''>Select Number</option>
            <?php
             if(isset($number->incoming_phone_numbers))
                  {
                        foreach($number->incoming_phone_numbers as $num){
                       
                        if(!in_array($num->phone_number,$used_num))
                        {
                            if(in_array($num->phone_number,$did_num))
                            echo "<option value='$num->sid|$num->phone_number'>$num->phone_number(Dedicated)</option>";
                            else
                             echo "<option value='$num->sid|$num->phone_number'>$num->phone_number</option>";
                        }
                        
                     }
                }   
            return "";
        }
    }
    
    public function send_sms_broadcast($To, $body, $callbackUrl, $media_url="", $user_id="", $broadcast_id, $subscriber_id,$group_id)
    {
        $sid = $utype = '';
        $check = array();
        if($user_id!="")
        {
                $utype = 'main';
                $settings = Setting::where('user_id',$user_id)->first();
                $this->TwilioSid = $settings->twilio_sid;
                $this->TwilioToken = $settings->twilio_token;
            
        }
            $campaign_num = Group::where("id",$group_id)->first();
            if($campaign_num)
            {
                $service = SmsService::find($campaign_num->service_id);
            }
        $url = "https://$this->TwilioSid:$this->TwilioToken@api.twilio.com/2010-04-01/Accounts/$this->TwilioSid/Messages";
        $val = array(
                "To"=>$To,
                "MessagingServiceSid"=>$service->twilio_msg_sid,
                "Body"=>$body,
                "StatusCallback"=>$callbackUrl,
                "callbackHttpMethod"=>"post"
            );
        if($media_url != ''){
            $val['MediaUrl'] = $media_url;
        }
        //mail('nisar@nimblewebsolutions.com', 'media array', print_r($val, true));

        $delivery_status = 'failed';
        $error = "";        

            $ch = curl_init(); // Initialize the curl
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($ch, CURLOPT_URL, $url);  // set the opton for curl
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);// set the option to transfer output from script to curl
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $val);
            $response = curl_exec($ch);
            curl_close($ch);

            $check = (array)simplexml_load_string($response);

            if(!isset($check['RestException'])){
                $delivery_status = 'queued';
                $sid = $check['Message']->Sid;
            }else
            {
                //$f = fopen("Error2.txt",'w');
                   // fwrite($f, print_r($check['RestException']));
                   // fclose($f);
                $error = $check['RestException']->Message;
            }

        

        $history = new BroadcastSmsHistory();
        $history->broadcast_id = $broadcast_id;
        $history->subscriber_id = $subscriber_id;
        $history->to_number = $To;
        $history->from_number = "";
        $history->delivery_status = $delivery_status;
        $history->body = $body;
        $history->sms_sid = $sid;
        $history->json_res = json_encode($check);
        $history->error = $error;
        $history->save();
        
        

        return $response;
    }
    
  
    
}
