<?php

namespace App\Jobs;

use App\BroadcastSmsHistory;
use Illuminate\Bus\Queueable;
use App\Setting;
use App\User;
use Carbon\Carbon;
use App\Broadcast;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use App\Http\Controllers\TwilioController;

class SendImmidiateSmsBroadcast implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    protected $subscriber;
    protected $twilio;
    protected $data;

    //send by sms/email/both
    protected $send_by;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($subs, $data, $sendBy)
    {
        $this->subscriber = $subs;
        $this->data = $data;
        $this->send_by = $sendBy;
        $this->twilio = new TwilioController();
    }


    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        //$data2 = print_r($this->data, true);
        //$subbb = print_r($this->subscriber, true);
        /*mail('sajawal@nimblewebsolutions.com',
            'Testing sms try block',
            "$data2 $this->send_by"
        );*/
        $disable_time  = [0,1,2,3,4,5,6,7,22,23];
        
            try {
                if ($this->attempts() < 2) {

                    $subscriber = $this->subscriber;
                    $sms_data = $this->data;
                    
                    
                 
                        $settings = Setting::where('user_id', $sms_data['broadcast_user_id'])->first();
                    
                    
                    $timezone_val = $settings->timezone;
                    $timezone = preg_replace('/\-/', '/', $timezone_val);
                    
                    if($timezone_val=='' || $timezone_val==null){
                        $timezone = 'America/Chicago';
                    }
                    
                    $pass = false;
                    $currentHr =  Carbon::now($timezone)->format("H");
                    $boardcast = Broadcast::find($sms_data['broadcast_id']);
                    $text = $sms_data['text'];
                        
                    $subscriber = $this->subscriber;
                    $sms_data = $this->data;
                    $response = $this->twilio->send_sms_broadcast(
                        $subscriber->phone,
                        $text,
                        $sms_data['callbackUrl'],
                        $sms_data['media_url'],
                        $sms_data['broadcast_user_id'],
                        $sms_data['broadcast_id'],
                        $subscriber->id,
                        $sms_data['group_id']
                    );
                        
                        
                        
                        
                        //$f = fopen("Error.txt",'w');
                        //fwrite($f, $response);
                        //fclose($f);
                        
                    
                    
                    
                }

            } catch (\Exception $e) {
                /*mail('sajawal@nimblewebsolutions.com',
                    'Testing Immediate Broadcast SMS Queue Exception caught in handle',
                    "Exception Message: $e->getMessage()"
                );*/
                $f = fopen("Error.txt",'w');
                    fwrite($f, $e->getMessage());
                    fclose($f);
            }
        
    }
}
