@extends('admin.layouts.app')
@section('title',"Phone Numbers")
@section('content')
<link href="assets/plugins/custom/datatables/datatables.bundle.css" rel="stylesheet" type="text/css" />
<div class="row">
    <div class="col-md-12">
        <button onclick="showmod()" type="button" class="btn btn-outline-brand"><i class="la la-plus"></i>Add New Phone</button>
    </div>
</div>
<br />
<div class="row">
    <div class="col-md-12 col-lg-12">
    
    <div class="kt-portlet kt-portlet--mobile">
								<div class="kt-portlet__head">
									<div class="kt-portlet__head-label">
										<h3 class="kt-portlet__head-title">
											Phone List
										</h3>
									</div>
                                    <div class="kt-portlet__head-toolbar">
										<div class="kt-portlet__head-toolbar-wrapper">
											<div class="dropdown dropdown-inline">
												<button id="reloadtable" title="Refresh" onclick="$('#datatable').DataTable().ajax.reload()" type="button" class="btn  btn-sm btn-outline-brand">
													<i class="la la-refresh"></i>
												</button>
												<button id="loadingm" style="display: none;" class="btn btn-primary" type="button">
														<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
														Processing...
												</button>
											</div>
										</div>
									</div>
								</div>
								<div class="kt-portlet__body">

									<!--begin: Datatable -->
									<table class="table table-striped- table-bordered table-hover table-checkable" id="datatable">
										<thead>
											<tr>
												<th>ID</th>
                                                <th>Phone Numbers</th>
                                                <th>Created At</th>
                                                <th>Action</th>
											</tr>
										</thead>
									</table>

									<!--end: Datatable -->
								</div>
							</div>
    </div>
</div>

<div id="service_form" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="standard-modalLabel" aria-hidden="true">
                <div class="modal-dialog modal-dialog-scrollable">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h4 class="modal-title" id="standard-modalLabel">Add new number to service</h4>
                        </div>
                        <div class="modal-body">
                            <div class="row">
                                <div class="col-12">
                                
                                 <form id="save_service" method="post">
                               
                                   <input name="id" value="{{ $_REQUEST['id'] }}" type="hidden" />
        
                                   @csrf
                                    
                                    
                                      
                                      <div class="form-group clearfix">

                                        <label class="col-5 control-label" for="">Select Phone Numbers</label>

                                        <div class="col-12">
                                            <div class="form-group clearfix">
                                            <select style="width: 100%;" name="phone_number[]" id="phone_number" class="kt-select2 select2 form-control select2-multiple" data-toggle="select2" multiple="multiple" data-placeholder="Choose ...">

                                                <option value="">Select Phone Number</option>
                                                 <?php
                                                $number = json_decode($number);
                                                if(isset($number->incoming_phone_numbers))
                                                {
                                                        foreach($number->incoming_phone_numbers as $num){
                                                        
                                                        if(!in_array($num->phone_number,$already_phone))
                                                          echo "<option value='$num->sid|$num->phone_number'>$num->phone_number $num->friendly_name</option>";
                                                        
                                                     }
                                                } 
                                                ?>

                                            </select>
                                            </div>
                                        </div>
                                       
                                      </div>
                                      
                                      <div class="modal-footer">
                                        <button type="button" class="btn btn-light" data-dismiss="modal">Close</button>
                                        <button type="submit" class="loading btn btn-primary">Save</button>
                                    </div>
                                 </form>
                                   
                                </div>
                            </div> 
                        </div>
                        
                    </div><!-- /.modal-content -->
                </div><!-- /.modal-dialog -->
            </div><!-- /.modal -->
            
    <div id="stats_modal" class="modal fade bd-example-modal-lg" tabindex="-1" role="dialog" aria-labelledby="myLargeModalLabel" aria-modal="true" aria-hidden="true">
		<div class="modal-dialog modal-lg">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title">Number Stats</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true"></span>
					</button>
				</div>
				<div class="modal-body">
				
            		<div class="row">
                        
                        
                        <div class="col-6">
                            	<button type="button" class="btn btn-block btn-info btn-tallest"><i class="la la-paper-plane"></i> Sent <i id="sent_stats"></i></button>
                        </div>
                            <div class="col-6">
                        <button type="button" class="btn btn-block btn-danger btn-tallest"><i class="la la-close"></i> Failed <i id="fail_stats"></i></button>
                            </div>
                        
                        
                    </div>
                    <br />
                    <div class="row">
                    
                        <div class="col-6">
                            <button type="button" class="btn btn-block btn-success btn-tallest"><i class="la la-check"></i> Delivered <i id="delivered_stats"></i></button>
                         </div>
                         
                         <div class="col-6">
                            <button type="button" class="btn btn-block btn-warning btn-tallest"><i class="la la-clock-o"></i> Queued <i id="queue_stats"></i></button>
                         </div>
                    </div>
            				
            		
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-outline-brand" data-dismiss="modal">Close</button>
				</div>
			</div>
		</div>
	</div>        

@endsection
@section('script')
<script src="assets/plugins/custom/datatables/datatables.bundle.js" type="text/javascript"></script>
<script src="{{ url('assets/js/pages/components/extended/sweetalert2.js')}}" type="text/javascript"></script>
<script src="https://cdn.jsdelivr.net/npm/select2@4.0.13/dist/js/select2.min.js"></script>
<script>
function showChart(sent,fail,delivered)
{
  
                
                var e = {
					type: "doughnut",
					data: {
						datasets: [{
							data: [sent, fail,delivered],
							backgroundColor: [KTApp.getStateColor("info"), KTApp.getStateColor("danger"),KTApp.getStateColor("success")]
						}],
						labels: ["Sent", "Failed","Delivered"]
					},
					options: {
						cutoutPercentage: 75,
						responsive: !0,
						maintainAspectRatio: !1,
						legend: {
							display: !1,
							position: "top"
						},
						title: {
							display: !1,
							text: "Number Stats"
						},
						animation: {
							animateScale: !0,
							animateRotate: !0
						},
						tooltips: {
							enabled: !0,
							intersect: !1,
							mode: "nearest",
							bodySpacing: 5,
							yPadding: 10,
							xPadding: 10,
							caretPadding: 0,
							displayColors: !1,
							backgroundColor: "#5578eb",
							titleFontColor: "#ffffff",
							cornerRadius: 4,
							footerSpacing: 0,
							titleSpacing: 0
						}
					}
				};
					a = document.getElementById("msg_chart").getContext("2d");
				new Chart(a, e)
}

function showmod()
{
    $("#service_form").modal("show");
    $("#save_service").resetForm();
}

function stats(id)
{
    $("#loadingm").show();
    $.get("{{ route('NumberStats') }}",{number:id},function(res){
        $("#loadingm").hide();
        $("#stats_modal").modal('show');
        //showChart(res.sent,res.fail,res.delivered);
        $("#sent_stats").text(res.total);
        $("#queue_stats").text(res.queue);
        $("#fail_stats").text(res.fail);
        $("#delivered_stats").text(res.delivered);
        //alert(res.delivered);
    })
}
function deleteFun(id){ 
 
 
 swal.fire({
          title: 'Are you sure?',
          text: "You won't be able to revert this!",
          type: 'warning',
          showCancelButton: true,
          confirmButtonColor: '#3085d6',
          cancelButtonColor: '#d33',
          confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
          if (result.value) {
            $("#loadingm").show();
            $.post("{{ Route('del_numbers') }}",{id:id,_token:"{{ csrf_token() }}"},function(res){
                $("#loadingm").hide();
                if(res=='1')
                {
                   swal.fire("Done!", "Phone Number successfully deleted!", "success");   
                    $('#reloadtable').click();
                }else{
                    swal.fire({
                      title: 'Error!',
                      text: 'Error while deleting!',
                      type: 'error',
                      confirmButtonText: 'Ok'
                    })
                }
            })
            
          }
        })
 
 
}

 $(document).ready(function(){
     
     
    /* var e = {
					type: "doughnut",
					data: {
						datasets: [{
							data: [5, 5,5],
							backgroundColor: [KTApp.getStateColor("info"), KTApp.getStateColor("danger"),KTApp.getStateColor("success")]
						}],
						labels: ["Sent", "Failed","Delivered"]
					},
					options: {
						cutoutPercentage: 75,
						responsive: !0,
						maintainAspectRatio: !1,
						legend: {
							display: !1,
							position: "top"
						},
						title: {
							display: !1,
							text: "Number Stats"
						},
						animation: {
							animateScale: !0,
							animateRotate: !0
						},
						tooltips: {
							enabled: !0,
							intersect: !1,
							mode: "nearest",
							bodySpacing: 5,
							yPadding: 10,
							xPadding: 10,
							caretPadding: 0,
							displayColors: !1,
							backgroundColor: "#5578eb",
							titleFontColor: "#ffffff",
							cornerRadius: 4,
							footerSpacing: 0,
							titleSpacing: 0
						}
					}
				},
					a = document.getElementById("msg_chart").getContext("2d");
				new Chart(a, e)
     */
     
     $('.select2').select2({
  placeholder: 'This is my placeholder',
  allowClear: true
});
     var id = '<?php echo $_GET['id'];?>'
     
     $('#datatable').DataTable({          
		processing: true,
		serverSide:true,
     ajax: "{{ route('phone_num_list') }}?id="+id,
  columns : [ 
		{ data: 'id', name: 'id' },
        { data: 'phone_number', name: 'phone_number' },
		{ data: 'created_at', name: 'created_at' },
		{ data: 'action', name: 'action', orderable: false, searchable: false}
		
		]
    });
    $('#save_service').submit(function () {
          
            var data = new FormData(this);
            if($("#phone_number").val()!="")
            {
                $('.loading').addClass("kt-spinner kt-spinner--light kt-spinner--right");
                $('.loading').prop('disabled', true); 
                $.ajax({
                    url: "{{ route('add_numbers') }}",
                    data: data,
                    contentType: false,
                    processData: false,
                    type: 'POST',
                    success: function(res){
                       $('.loading').removeClass("kt-spinner kt-spinner--light kt-spinner--right");
                       $('.loading').prop('disabled', false); 
                        if(res == '1')
                        {
                            swal.fire("Saved!","Number added successfully", "success");
                            
                            $('#reloadtable').click();
                            $("#service_form").modal("hide");
                            $("#save_service").resetForm();
                            $("input[name='id']").val('');  
                            location.reload();              
                            
                        }else
                        {
                            
                            swal.fire("Error!", "Error while adding number!", "error");
                                
                        }
                           
                      }
                });
                
                return false;
            }else
            {
                swal.fire("Note!", "Please Select Phone Number First!", "warning");
            }
        });
    
 });
 </script>
@endsection
