@extends('admin.layouts.app')
@section('title',"Call History")
@section('content')
<?php

?>
<link href="assets/plugins/custom/datatables/datatables.bundle.css" rel="stylesheet" type="text/css" />



<div class="row">
    <div class="col-md-12 col-lg-12">
    
    <div class="kt-portlet kt-portlet--mobile">
								<div class="kt-portlet__head">
									<div class="kt-portlet__head-label">
										<h3 class="kt-portlet__head-title">
											Call History
										</h3>
									</div>
                                    <div class="kt-portlet__head-toolbar">
										<div class="kt-portlet__head-toolbar-wrapper">
											<div class="dropdown dropdown-inline">
												<button id="reloadtable" title="Refresh" onclick="$('#datatable').DataTable().ajax.reload()" type="button" class="btn  btn-sm btn-outline-brand">
													<i class="la la-refresh"></i>
												</button>
                                                <button id="loadingm" style="display: none;" class="btn btn-primary" type="button">
														<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
														Processing...
													</button>
												
											</div>
										</div>
									</div>
								</div>
								<div class="kt-portlet__body">

									<!--begin: Datatable -->
									<table class="table table-striped- table-bordered table-hover  dataTable no-footer dtr-inline" id="datatable">
										<thead>
											<tr>
												<th>ID</th>
                                                <th>From</th>
												<th>To</th>
                                                <th>Recording</th>
                                                <th>Forward To</th>
												<th>Created At</th>
                                                <th>Action</th>
											</tr>
										</thead>
									</table>

									<!--end: Datatable -->
								</div>
							</div>
    </div>
</div>



@endsection
@section('script')
<script src="assets/plugins/custom/datatables/datatables.bundle.js" type="text/javascript"></script>
<script src="assets/js/pages/components/datatables/basic/scrollable.js" type="text/javascript"></script>
<script src="{{ url('assets/js/pages/components/extended/sweetalert2.js')}}" type="text/javascript"></script>

<script>

function showmod()
{
    $("#contact_form").modal("show");
    $('input[name="id"]').val('');
    $("#save_contact").resetForm();
}

function editFun(id)
{
    $("#loadingm").show();
    $.get("{{ route('get_contact') }}",{id:id},function(res){
        $("#loadingm").hide();
        $.each(res,function(k,v){
            console.log(k);
            $('input[name="'+k+'"]').val(v);
        })
        $('select[name="group_id[]"]').val(res.group_id).trigger("change");
        $("#contact_form").modal("show");
    })
}
function deleteFun(id)
{
    
        swal.fire({
          title: 'Are you sure?',
          text: "You won't be able to revert this!",
          type: 'warning',
          showCancelButton: true,
          confirmButtonColor: '#3085d6',
          cancelButtonColor: '#d33',
          confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
          if (result.value) {
            $("#loadingm").show();
            $.get("{{ route('del_recording') }}",{id:id},function(res){
               $("#loadingm").hide();
                if(res=='1')
                {
                   swal.fire(
                      'Deleted!',
                      'Recording has been deleted.',
                      'success'
                    );
                    $('#reloadtable').click();
                }else{
                    swal.fire({
                      title: 'Error!',
                      text: 'Error while deleting!',
                      type: 'error',
                      confirmButtonText: 'Ok'
                    })
                }
            })
            
          }
        })
    
}
    $(document).ready(function(){
        
        ///$(".kt-select2").select2();
        
        $('#datatable').DataTable({
            //"scrollX": true,
		processing: true,
		serverSide:true,
         "order": [[ 0, "desc" ]],
        "drawCallback" : function(){

                     /*  $('.userstatus').on('change', function (event) {
                                console.log(event.target.checked);
                            var chk;
                            if(event.target.checked==true)
                            {
                                chk=1;
                            }else
                            {
                                chk=0;
                            }
                            console.log(chk);
                                   $.get("contact-status",{id:event.target.value,status:chk},function(res){
                                    console.log(res);
                                });
                            }); */
            },
        ajax: "{{ route('call_list') }}",
        columns : [ 
    		{ name: 'call_history.id', data: 'id' },
            { name: 'call_history.from_num', data: 'from_num' },
            { name: 'call_history.to_num', data: 'to_num' },
    		{ name: 'call_recordings.recording', data: 'recording' },
            { name: 'call_history.forward_to', data: 'forward_to' },
    		{ data: 'created_at', name: 'created_at'},
    		{ data: 'action', name: 'action', orderable: false, searchable: false}
    		]
        });
        
        
        $("#save_contact").submit(function(){
            if($("#state").val()=='')
            {
                swal.fire("Info!", "Select a state!", "warning");
                return false;
            }
            
            if($("#service_id").val()=='')
            {
                swal.fire("Info!", "Select a message service!", "warning");
                return false;
            }
                $('.loading').addClass("kt-spinner kt-spinner--light kt-spinner--right");
                $('.loading').prop('disabled', true); 
                
                $.post('{!! route("contacts.store") !!}',$(this).serialize(),function(res){
                    $('.loading').removeClass("kt-spinner kt-spinner--light kt-spinner--right");
                    $('.loading').prop('disabled', false); 
                    if(res=='1')
                    {
                        swal.fire({
                          title: 'Good Job!',
                          text: 'Contact saved successfully!',
                          type: 'success',
                          confirmButtonText: 'Ok'
                        })
                        $('#reloadtable').click();
                        $("#contact_form").modal("hide");
                        $("#save_contact").resetForm();
                    }else
                    {
                        swal.fire({

                          title: 'Error!',
    
                          text: res,
    
                          type: 'error',
    
                          confirmButtonText: 'Ok'
    
                        })
                    }
                })
                
            return false;
        });
        
         $("#f_group_id").change(function(){
                    
                    if($("#f_group_id option:selected").text()=="")
                    {
                        swal("Error!","Please select campaign!", "error");
                    }else if($("#f_group_id option:selected").text()=="All")
                    {
                        $('#datatable').DataTable().columns(2).search('').draw();
                    }else
                    {
                         $('#datatable').DataTable().columns(2).search( $("#f_group_id option:selected").text() ).draw();
                    }
                    
                });
        
        
    });
</script>
@endsection
