<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    //echo bcrypt("temp@123");
    return redirect('login');
});
Route::get('test-save-hash', 'ContactController@savehash');

Route::any('/sms-controlling', 'BroadcastController@SmsCon')->name('smscon');
Route::any('/call-controlling', 'SettingController@CallCon')->name('callcon');
Route::any('/sms-status',"BroadcastController@SmsStatuscallback");
Route::any("/get-lead","ContactController@getLead");
Route::get("/send-offers","FollowupController@sendOffers");
Route::get("/send-offers2","FollowupController@sendOffers2");
Route::any('/call-recording-post',"SettingController@handleRecording");
Auth::routes();

Route::group(['middleware' => ['auth'] ], function() {
    
Route::get('/home', 'HomeController@index')->name('home');

Route::resource('/settings', 'SettingController');
Route::resource('/phone-services', 'PhoneServiceController');
Route::resource('/groups', 'GroupController');
Route::resource('/contacts', 'ContactController');
Route::resource('/campaigns', 'CampaignController');
Route::resource('/offers', 'OfferController');
Route::resource('/source', 'SourceController');
Route::resource('/broadcast', 'BroadcastController');

Route::get('/phone-service', 'PhoneServiceController@index');
Route::get("/phone-numbers",'PhoneServiceController@phone_num')->name("phone_num");
Route::get('/phone-num-list', 'PhoneServiceController@phone_num_list')->name('phone_num_list');
Route::get('/phone-service-list', 'PhoneServiceController@phone_service_list')->name('phone_service_list');
Route::post("/del-sms-service","PhoneServiceController@del_service")->name('del_sms_service');
Route::post("/del-numbers","PhoneServiceController@del_numbers")->name('del_numbers');
Route::post("/add-number-service","PhoneServiceController@addNumber")->name('add_numbers');
Route::get("/get-service","PhoneServiceController@show")->name('get_service');

Route::get('/list-groups', 'GroupController@listGroups')->name("list_groups");
Route::get('/get-group', 'GroupController@show')->name("get_group");
Route::get('/del-group', 'GroupController@del_group')->name("del_group");


Route::get('/list-contacts', 'ContactController@listContacts')->name("list_contacts");
Route::get('/get-contact', 'ContactController@show')->name("get_contact");
Route::get('/del-contact', 'ContactController@del_contact')->name("del_contact");
Route::get('/del-contact-group', 'ContactController@del_contact_group')->name("del_contact_group");
Route::get('/contact-status', 'ContactController@conStatus')->name("conStatus");

Route::post('/import-contacts', 'ContactController@import_contacts')->name("imp_contacts");

Route::get("/profile","SettingController@profile");
Route::post("/save-profile","SettingController@saveProfile")->name('save_profile');

Route::get('/list-campaigns', 'CampaignController@listCamps')->name("list_camps");
Route::get('/del-campaign-group', 'CampaignController@delcampGroup')->name("del_camp_group");
Route::get('/add-new-followup', 'CampaignController@newOffer')->name("new_followup");
Route::get('/del-followup', 'CampaignController@delOffer')->name("del_followup");
Route::get('/check-offer',"CampaignController@checkOffer")->name('check_offer');
Route::get('/del-campaign',"CampaignController@delCampaign")->name('del_campaign');

Route::get('/list-offers', 'OfferController@listoffer')->name("list_offers");
Route::get('/get-offer', 'OfferController@show')->name("get_offer");
Route::get('/del-offer', 'OfferController@del_offer')->name("del_offer");


Route::get('/number-stats', 'HomeController@NumberStats')->name("NumberStats");
Route::get('/offer-stats', 'HomeController@offerStats')->name("offerstats");



Route::get('/failed-msgs', 'HomeController@failedMsgs');
Route::get('/failed-msgs-list', 'HomeController@failedMsgslist')->name("failedMsgs");

Route::get('/call-history', 'SettingController@CallHistory');
Route::get('/call-history-list', 'SettingController@CallHistorylist')->name("call_list");
Route::get('/set-call-url', 'PhoneServiceController@callUrl')->name("set_call_url");
Route::get("/del-recording","SettingController@DelRecordig")->name("del_recording");

Route::get("reporting","CampaignController@reporting");

Route::post("lead-report","CampaignController@lead_report")->name("lead_report1");

route::get("offer-performance","OfferController@offer_performance")->name('offer_performance');

Route::get("number-performance","PhoneServiceController@number_performance")->name("number_performance");

Route::get("fail-report","CampaignController@fail_report")->name("fail_report");


Route::get("offer-performance-export","OfferController@offerperformanceexport")->name("offer_perform_export");
Route::get("number-performance-export","PhoneServiceController@numberperformanceexport")->name("number_perform_export");
Route::get("failure-export","CampaignController@failureexport")->name("fail_export");

Route::get("state-filter","HomeController@stateFilter")->name("state_filter");
Route::get("offer-filter","HomeController@offer_filter")->name("offer_filter");


Route::get("list-source","SourceController@listSource")->name("list_source");
Route::get("get-source","SourceController@edit")->name("get_source");
Route::get("/del-source","SourceController@delSource")->name("del_source");


Route::get("list-broadcast","BroadcastController@listBroadcast")->name("list_broadcast");
Route::get("broadcast-sms-report/{id}","BroadcastController@smsHistory");
Route::get("broadast-history","BroadcastController@smsBhis")->name("sms_his");
Route::get('/del-broadcast',"BroadcastController@delBroadcast")->name('del_broadcast');

Route::get('/list-cons',"BroadcastController@listCons")->name("list_conversations");
Route::get('/inbox',"BroadcastController@inbox");
Route::get('/inbox-chat',"BroadcastController@chat");
Route::get('export-chat',"BroadcastController@exportChat");
Route::get('del-conv',"BroadcastController@delConv")->name("del_conv");
Route::get("/status-chats","BroadcastController@setConvstatus")->name("chat_status");

Route::post('/send-chat',"BroadcastController@sendChat")->name("send2waychat");
});
